#pragma GCC optimize("Ofast")
//#pragma GCC optimization("unroll-loops")
//#pragma GCC target("sse3")


#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <vector>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <memory.h>
#include <string>
#include <string.h>
#include <random>
#include <assert.h>



using namespace std;

typedef long long ll;
#define rep(i, n) for (int i = 0; i <(n); i++)
#define all(x) x.begin(),x.end()
#define sz(x) ((int)x.size())
#define rall(x) x.rbegin(),x.rend()
#define per(i, n) for (int i = (n) - 1; i>=0;i--)
#define mp make_pair
#define ff first
#define ss second
#define debug(x) { cerr << #x << " = " << x << "\n"; }
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef set<int> si;
typedef set<ll> sll;


mt19937 rng(5);

struct FenwickTree {
	vector<int> fen;
	int N;
	void init(int n) {
		N = n;
		fen.assign(N, 0);
	}

	void add(int i, int x) {
		for (; i < N; i = i | (i + 1)) {
			fen[i] += x;
		}
	}

	int get_sum(int i) {
		int sum = 0;
		for (; i >= 0; i = ((i + 1) & i) - 1) {
			sum += fen[i];
		}
		return sum;
	}

	int get_sum(int l, int r) {
		return get_sum(r) - get_sum(l - 1);
	}
};


struct KuteArray {
	struct Node {
		int prior;
		int val;
		int sz;
		int sum;
		Node *l, *r;

		Node(int x) {
			prior = rng();
			val = x;
			sum = x;
			sz = 1;
			l = r = nullptr;
		}
	};


	int get_size(Node *tree) {
		if (tree == nullptr) return 0;
		return tree->sz;
	}

	int get_sum(Node *tree) {
		if (tree == nullptr) return 0;
		return tree->sum;
	}

	void pull(Node *tree) {
		if (tree == nullptr) return;
		tree->sum = get_sum(tree->l) + get_sum(tree->r) + tree->val;
		tree->sz = get_size(tree->l) + get_size(tree->r) + 1;
	}


	Node *merge(Node *left, Node *right) {
		if (left == nullptr || right == nullptr) {
			return left == nullptr ? right : left;
		}
		if (left->prior > right->prior) {
			left->r = merge(left->r, right);
			pull(left);
			return left;
		}
		else {
			right->l = merge(left, right->l);
			pull(right);
			return right;
		}
	}

	pair<Node*, Node*> split(Node *tree, int k) {
		if (tree == nullptr) {
			return { nullptr, nullptr };
		}

		if (get_size(tree->l) + 1 <= k) {
			auto tmp = split(tree->r, k - get_size(tree->l) - 1);
			tree->r = tmp.first;
			pull(tree);
			return { tree, tmp.second };
		}
		else {
			auto tmp = split(tree->l, k);
			tree->l = tmp.second;
			pull(tree);
			return { tmp.first, tree };
		}
	}

	Node *root = nullptr;

	void erase(int i) {
		auto tmp = split(root, i);
		auto rr = split(tmp.first, 1);
		root = merge(tmp.first, rr.second);
	}

	void insert(int i, int x) {
		auto tmp = split(root, i);
		Node *nn = new Node(x);
		root = merge(tmp.first, merge(nn, tmp.second));
	}

	int get(int i) {
		auto tmp = split(root, i);
		auto rr = split(tmp.first, 1);
		int ans = rr.first->val;
		root = merge(tmp.first, merge(rr.first, rr.second));
		return ans;
	}
};


struct Treap {
	struct Node {
		int prior;
		int val;
		int sz;
		int sum;
		Node *l, *r;

		Node(int x) {
			prior = rng();
			val = x;
			sum = x;
			sz = 1;
			l = r = nullptr;
		}
	};

	int get_size(Node *tree) {
		if (tree == nullptr) return 0;
		return tree->sz;
	}

	int get_sum(Node *tree) {
		if (tree == nullptr) return 0;
		return tree->sum;
	}

	void pull(Node *tree) {
		if (tree == nullptr) return;
		tree->sum = get_sum(tree->l) + get_sum(tree->r) + tree->val;
		tree->sz = get_size(tree->l) + get_size(tree->r) + 1;
	}


	Node *merge(Node *left, Node *right) {
		if (left == nullptr || right == nullptr) {
			return left == nullptr ? right : left;
		}
		if (left->prior > right->prior) {
			left->r = merge(left->r, right);
			pull(left);
			return left;
		}
		else {
			right->l = merge(left, right->l);
			pull(right);
			return right;
		}
	}

	pair<Node*, Node*> split(Node *tree, int x) {
		if (tree == nullptr) {
			return { nullptr, nullptr };
		}

		if (tree->val <= x) {
			auto tmp = split(tree->r, x);
			tree->r = tmp.first;
			pull(tree);
			return { tree, tmp.second };
		}
		else {
			auto tmp = split(tree->l, x);
			tree->l = tmp.second;
			pull(tree);
			return { tmp.first, tree };
		}
	}

	Node *root = nullptr;
};


struct SegmentTree {
	vector<int>t;
	int N;
	
	void init(int n) {
		N = 1;
		while (N < n) N *= 2;
		N *= 2;
		t.assign(2 * N, 0);
	}

	int get(int l, int r) {
		l += N, r += N + 1;
		int ans = 0;
		for (; l < r; l /= 2, r /= 2) {
			if (l & 1) {
				ans = max(ans, t[l++]);
			}
			if (r & 1) {
				ans = max(ans, t[--r]);
			}
		}
		return ans;
	}

	void upd(int i, int x) {
		i += N;
		t[i] = x;
		i /= 2;
		while (i > 0) {
			t[i] = max(t[i * 2], t[i * 2 + 1]);
			i /= 2;
		}
	}
};


int gcd(int a, int b) {
	if (b == 0)return a;
	return gcd(b, a % b);
}

void solve() {
	int a, b;
	cin >> a >> b;
	cout << a * b << '\n';
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);




	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}


	return 0;
}