#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T>
void operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
}

template<typename T>
void operator<<(ostream &os, pair<T, T> &v) {
    os << v.first << ' ' << v.second;
}

#define pb push_back
#define all(a) a.begin(), a.end()
#define sqr(a) ((a) * (a))
#define nl '\n'
#define forn(i, n) for (int i = 0; i < n; i++)

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pair<int, int>> vpi;
typedef long long ll;
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(10);
}

const int MAXN = 1e5 + 10;
const int MAXE = 1e5 + 10;
const int K = 100 + 5;

#define int ll

bool Check(int m, int c, vi &a) {
    if (*max_element(all(a)) >= m) {
        return 0;
    }
    vi b(a.size());
    b[0] = a[0];
    for (int i = 1; i < a.size(); i++) {
        b[i] = (b[i - 1] + c) % m;
    }
    return a == b;
}

void Solve() {
    int n;
    cin >> n;
    vi a(n);
    cin >> a;
    if (n == 1) {
        cout << 0 << nl;
        return;
    }
    set<int> s;
    for (int i = 1; i < n; i++) {
        s.insert(a[i] - a[i - 1]);
    }
    if (s.size() == 1) {
        cout << 0 << nl;
        return;
    }
    if (s.size() > 2) {
        cout << -1 << nl;
        return;
    }
    int a1 = *s.begin(), a2 = *s.rbegin();
    if (a1 == -a2) {
        vi aa = a;
        sort(all(aa));
        if (a == aa) {
            cout << 0 << nl;
            return;
        }
        int q = a[1] - a[0];
        for (int i = 2; i < n; i++) {
            int w = a[i] - a[i - 1];
            if (w != -q) {
                cout << -1 << nl;
                return;
            }
            q = w;
        }
        if (Check(2 * abs(q), abs(q), a)) {
            cout << 2 * abs(q) << ' ' << abs(q) << nl;

        } else {
            cout << -1 << nl;
        }
        return;
    }
    if (a1 < 0 && a2 > 0) {
        if (Check(abs(a1) + abs(a2), a2, a)) {
            cout << abs(a1) + abs(a2) << ' ' << a2 << nl;
        } else {
            cout << -1 << nl;
        }
        return;
    }
    cout << -1 << nl;
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    while (t--) {
        Solve();
    }
    return 0;
}