#include <bits/stdc++.h>
#include <ostream>

using ll = long long;
using namespace std;
#define int long long

int n;

bool check_generation(vector<int> &as, int c, int m) {
    int a = as[0] % m;
    if (a != as[0]) return false;
    for (int i = 1; i < as.size(); ++i) {
        a = (a + c) % m;
        if (a != as[i]) return false;
    }
    return true;
}

int solve() {
    if (!(cin >> n))
        return 1;
    vector<long long> as(n);
    vector<long long> deltas(n - 1);
    int max_val = 0;
    for (int i = 0; i < n; ++i) {
        cin >> as[i];
        max_val = max(max_val, as[i]);
        if (i > 0) {
            deltas[i - 1] = as[i] - as[i - 1];
        }
    }

    bool is_all_non_negative = true;
    set<int> positive_deltas;
    set<int> negative_deltas;
    vector<int> neg_positions;
    for (int i = 0; i < n - 1; ++i) {
        if (deltas[i] < 0) {
            is_all_non_negative = false;
            neg_positions.emplace_back(i);
            negative_deltas.insert(deltas[i]);
        } else {
            positive_deltas.insert(deltas[i]);
        }
    }
    if (positive_deltas.size() > 1 || negative_deltas.size() > 1) {
        cout << -1 << '\n';
        return 0;
    }
    if (is_all_non_negative) {
        cout << 0 << '\n';
        return 0;
    }
    int c = -1;
    if (!positive_deltas.empty()) {
        c = *positive_deltas.begin();
    }
    if (n <= 2) {
        cout << 0 << '\n';
        return 0;
    }
    if (c != -1) {
        int a = as[neg_positions[0]];
        int m = a + c - as[neg_positions[0] + 1];
        if (!check_generation(as, c, m)) {
            cout << -1 << '\n';
        } else {
            cout << m << ' ' << c << '\n';
        }
        return 0;
    } else {
        cout << 0 << '\n';
        return 0;
    }
    return 0;
}

signed main() {

#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif

    iostream::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1e9;
     cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "--------------------\n";
#endif
    }
}
