#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <random>
#include <cstdio>
#include <string>
#include <ctime>

#define pb push_back
#define rs resize
#define mp make_pair

typedef long long ll;

using namespace std;

const int di[4] = {-1, 0, 1, 0};
const int dj[4] = {0, 1, 0, -1};
const int INF = 2e9;
const ll INF2 = 2e18;

ostream &operator << (ostream &out, vector <int> &v){
	for(int i = 0; i < v.size(); i++){
		out<<v[i]<<" ";
	}
	out<<"\n";
	return out;
}

istream &operator >> (istream &in, vector <int> &v){
	for(int i = 0; i < v.size(); i++){
		in>>v[i];
	}
	return in;
}

ostream &operator << (ostream &out, vector <ll> &v){
	for(int i = 0; i < v.size(); i++){
		out<<v[i]<<" ";
	}
	out<<"\n";
	return out;
}

istream &operator >> (istream &in, vector <ll> &v){
	for(int i = 0; i < v.size(); i++){
		in>>v[i];
	}
	return in;
}

ostream &operator << (ostream &out, vector <vector <int> > &v){
	for(int i = 0; i < v.size(); i++){
		for(int j = 0; j < v[i].size(); j++){
			out<<v[i]<<" ";
		}
		out<<"\n";
	}
	out<<"\n";
	return out;
}

ll dijkstra(int start, int end, int n, vector <vector <pair <int, int> > > &g){
	vector <ll> dist(n, INF2);
	set <pair <ll, int> > q;
	dist[start] = 0;
	q.insert({0, start});
	while(q.size()){
		int v = (*q.begin()).second;
		q.erase(q.begin());
		for(int i = 0; i < g[v].size(); i++){
			int u = g[v][i].first, cost = g[v][i].second;
			if(dist[u] > dist[v] + cost){
				q.erase({dist[u], u});
				dist[u] = dist[v] + cost;
				q.insert({dist[u], u});
			}
		}
	}
	return dist[end];
}

int main(){
	int t;
	cin>>t;
	while(t--){
		ll n;
		cin>>n;
		vector <ll> v;
		v.resize(n);
		cin>>v;
		if(v[0] == v[1]){
			bool b = false;
			for(int i = 1; i < n - 1; i++){
				if(v[i] != v[i + 1]){
					b = true;
					cout<<-1<<"\n";
					break;
				}
			}
			if(!b){
				cout<<0<<"\n";
			}
			continue;
		}
		if(n == 2 && v[0] >= v[1]){
			cout<<0<<"\n";
			continue;
		}
		bool f3 = false;
		ll d = -INF, m = -INF;
		d = v[1] - v[0];
		for(int i = 0; i < n - 1; i++){
			if(v[i + 1] - v[i] != d){
				f3 = true;
				break;
			}
		}
		if(!f3){
			cout<<0<<"\n";
			continue;
		}
		d = -INF;
		bool f = true;
		bool inf = true;
		for(int i = 0; i < n - 1; i++){
			if(v[i] >= v[i + 1]){
				inf = false;
				if(i == 0){
					continue;
				}
				m = v[i] + d - v[i + 1];
			}
			else{
				if(d != -INF && v[i + 1] - v[i] != d){
					cout<<-1<<'\n';
					f = false;
					break;
				}
				d = v[i + 1] - v[i];
			}
		}
		if(v[0] > v[1]){
			m = v[0] + d - v[1];
		}
		if(!f){
			continue;
		}
		if(inf){
			cout<<0<<"\n";
			continue;
		}
		bool f2 = true;
		for(int i = 0; i < n - 1; i++){
			if(v[0] >= m || v[i + 1] != (v[i] + d) % m){
				cout<<-1<<"\n";
				f2 = false;
				break;
			}
		}
		if(!f2){
			continue;
		}
		cout<<m<<" "<<d<<"\n";
	}
	return 0;
}
