// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define int long long

#ifdef LOCAL
	const int N = (1 << 10);
#else
	const int N = (1 << 20);
#endif

struct Seg_tree {
	int t[2 * N + 228];
	int mod[2 * N + 228];
	Seg_tree(vector<int> a) {
		fill(t, t + 2 * N + 228, 0);
		fill(mod, mod + 2 * N + 228, 0);
		int n = a.size();
		for (int i = 0; i < n; ++i) {
			t[i + N] = a[i];
		}
		for (int i = N - 1; i > 0; --i) {
			t[i] = max(t[2 * i], t[2 * i + 1]);
		}
	}

	void push(int i) {
		if (i < N) {
			mod[2 * i] += mod[i];
			mod[2 * i + 1] += mod[i];
		}
		t[i] += mod[i];
		mod[i] = 0;
	}

	int get(int v, int tl, int tr, int l, int r) {
		push(v);
		if (l <= tl && tr <= r) return t[v];
		if (tl >= r || tr <= l) return 0;
		int m = (tl + tr) / 2;
		return max(get(2 * v, tl, m, l, r), get(2 * v + 1, m, tr, l, r));
	}

	void update(int v, int tl, int tr, int l, int r, int x) {
		if (l <= tl && tr <= r) {
			mod[v] += x;
			push(v);
			return;
		}
		push(v);
		if (tl >= r || tr <= l) return;
		int m = (tl + tr) / 2;
		update(2 * v, tl, m, l, r, x);
		update(2 * v + 1, m, tr, l, r, x);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
};

signed main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
		cout.tie(nullptr);
		cout << fixed << setprecision(15);
	#endif
	int T;
	cin >> T;
	while (T --> 0) {
		int n;
		cin >> n;
		vector<int> a(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		if (n == 1) {
			cout << 0 << '\n';
			continue;
		}
		{
			bool eq = false;
			bool neq = false;
			for (int i = 1; i < n; ++i) {
				eq |= (a[i] == a[i - 1]);
				neq |= (a[i] != a[i - 1]);
			}
			if (eq && neq) {
				cout << -1 << '\n';
				continue;
			} else if (eq && !neq) {
				cout << 0 << '\n';
				continue;
			}
		}
		int pc = 0, nc = 0;
		bool ok = true;
		for (int i = 1; i < n; ++i) {
			int d = a[i] - a[i - 1];
			if (d > 0) {
				if (pc == 0) pc = d;
				if (pc != d) ok = false;
			} else if (d < 0) {
				if (nc == 0) nc = d;
				if (nc != d) ok = false;
			}
		}
		if (!ok) {
			cout << -1 << '\n';
			continue;
		}
		if (nc == 0 || pc == 0) {
			cout << 0 << '\n';
			continue;
		}
		int m = pc - nc;
		int c = pc;
		if (*max_element(a.begin(), a.end()) >= m) {
			cout << -1 << '\n';
			continue;
		}
		for (int i = 1; i < n; ++i) {
			if ((a[i - 1] + c) % m != a[i]) {
				cout << -1 << '\n';
				continue;
			}
		}
		cout << m << ' ' << c << '\n';
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s    ";
	#endif
	return 0;
}