#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <cmath>
#include <map>
#include <set>
#define MO 1000000007
#define MAXN 100000
#define MAXM 100000

using namespace std;

typedef long long ll;
typedef vector<long long> vll;
typedef vector<long> vl;
typedef vector<vl> vvl;

int gcd(int a, int b) {
    if(a<b)
        swap(a,b);
    while(a>0 && b>0) {
        a%=b;
        swap(a,b);
    }
    return a;
}

int lcm(int a, int b) {
    return a*b/gcd(a, b);
}

void fillPrime() {
    const int cacheSize=100;
    bool primeCache[cacheSize];
    for(int i=0;i<cacheSize;i++) {
        primeCache[i]=1;
    }
    for(int i=2;i<cacheSize;i++) {
        for(int j=i*2;j<cacheSize;j+=i) {
            primeCache[j]=0;
        }
    }
}


/*vl graph[MAXN];
bool used[MAXN];
void dfs(int v) {
    used[v]=1;
    for(int i=0;i<graph[v].size();i++) {
        if(used[v])
            continue;
        dfs(graph[v][i]);
    }
    used[v]=0;
}*/

/*vl mnozh(int n) {
    vl ans;
    for(int i=2;i<=sqrt(n);i++) {
        while(n%i==0) {
            ans.push_back(i);
            n/=i;
        }
    }
    if(n>1)
        ans.push_back(n);
    return ans;
}*/

/*vl tree(4*MAXN);
vl a(MAXN);

void build_tree(int v, int tl, int tr) {
    if(tl==tr) {
        tree[v]=a[tl];
    } else {
        int tm=(tl+tr)/2;
        build_tree(2*v, tl, tm);
        build_tree(2*v+1, tm+1, tr);
        tree[v]=tree[2*v]+tree[2*v+1];
    }
}

int get_sum(int v, int tl, int tr, int l, int r) {
    if(l>r || tr<l || tl>r) {
        return 0;
    }
    if(l<=tl && tr<=r) {
        return tree[v];
    }
    int tm=(tl+tr)/2;
    return get_sum(2*v, tl, tm, l, r)+get_sum(2*v+1, tm+1, tr, l, r);
}*/

void solve() {
    int n;
    cin >> n;
    int a[n];
    for(int i=0;i<n;i++) {
        cin >> a[i];
    }
    if(n==1) {
        cout << "0\n";
        return;
    }
    int dif=-1;
    for(int i=1;i<n;i++) {
        if(a[i]>=a[i-1]) {
            dif=a[i]-a[i-1];
            break;
        }
    }
    if(dif==-1) {
        dif=a[1]-a[0];
        for(int i=2;i<n;i++) {
            if(dif!=a[i]-a[i-1]) {
                cout << "-1\n";
                return;
            }
        }
        cout << "0\n";
        return;
    }
    bool correct=1;
    for(int i=2;i<n;i++) {
        if(dif!=a[i]-a[i-1]) {
            correct=0;
            break;
        }
    }
    int m=-1;
    for(int i=1;i<n;i++) {
        if(a[i]<a[i-1]) {
            m=a[i-1]+dif-a[i];
            break;
        }
    }
    if(m==-1) {
        if(correct) {
            cout << "0\n";
        } else {
            cout << "-1\n";
        }
        return;
    }
    for(int i=0;i<n;i++) {
        if(a[i]>=m) {
            cout << "-1\n";
            return;
        }
    }
    for(int i=1;i<n;i++) {
        if((a[i-1]+dif)%m!=a[i]) {
            cout << "-1\n";
            return;
        }
    }
    cout << m << " " << dif << "\n";
}

int main() {
    int t,n,m,lim;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}

