#ifdef FAIRLY_LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
using namespace std;

int ceil(int a, int b) {
    if (a % b) {
        return a / b + 1;
    }
    return a / b;
}

int main() {
#ifdef FAIRLY_LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;

    cin >> t;
    while (t --> 0) {
        int n, m;
        vector<vector<int>> free;
        vector<vector<int>> tr;

        cin >> n >> m;
        free.resize(m);
        tr.resize(n);
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            free[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> free[i][j];
                --free[i][j];
                tr[free[i][j]].push_back(i);
            }
        }
        int lim = ceil(m, 2);

        bool fl = true;
        for (int i = 0; i < n; ++i) {
            int cnt = 0;
            for (int day : tr[i]) {
                if (free[day].size() == 1) {
                    ++cnt;
                }
            }

            if (cnt > lim) {
                fl &= false;
            }
        }

        if (!fl) {
            cout << "NO\n";
        } else {
            cout << "YES\n";

            auto it = max_element(tr.begin(), tr.end(), [](vector<int> &a, vector<int> &b) {
                return a.size() < b.size();
            });

            vector<int> ans(m, -1);
            if (it->size() > lim) {
                sort(it->begin(), it->end(), [&](int a, int b) {
                    return free[a].size() < free[b].size();
                });

                for (int i = 0; i < lim; ++i) {
                    ans[*(it->begin() + i)] = it - tr.begin() + 1;
                }
                for (int i = 0; i < m; ++i) {
                    if (ans[i] == -1) {
                        ans[i] = (free[i][0] == (it - tr.begin()) ? free[i][1] : free[i][0]) + 1;
                    }
                }
            } else {
                for (int i = 0; i < m; ++i) {
                    ans[i] = free[i].front() + 1;
                }
            }

            for (int elem : ans) {
                cout << elem << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}