#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<utility>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<climits>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<random>
using namespace std;
#define int long long
mt19937 azino(777);
struct fenwick {
	vector<int> f;
	int n;
	void add(int i, int val) {
		for (; i < n; i |= (i + 1)) f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i) {
			ans += f[i];
		}
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
	fenwick(vector<int> a) {
		n = a.size();
		f.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			add(i, a[i]);
		}
	}
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
};
void solve() {
	int n, m;
	cin >> n >> m;
	vector<pair<vector<int>, int>> a(m);
	vector<int> cnt(n + 1, 0), cnt2(n + 1, 0);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		a[i].first.resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i].first[j];
			cnt[a[i].first[j]]++;
		}
		a[i].second = i;
	}
	sort(a.begin(), a.end(), [](pair<vector<int>,int> x, pair<vector<int>,int> y) {
		return x.first.size() < y.first.size();
		});
	vector<int> ans(m,0);
	for (int i = 0; i < m; ++i) {
		bool f = false;
		for (int j = 0; j < a[i].first.size(); ++j) {
			if (cnt[a[i].first[j]] <= (m + 1) / 2) {
				f = true;
				ans[a[i].second] = a[i].first[j];
				break;
			}
		}
		if (f) continue;
		f = false;
		for (int j = 0; j < a[i].first.size(); ++j) {
			if (cnt2[a[i].first[j]] < (m + 1) / 2){
				cnt2[a[i].first[j]]++;
				ans[a[i].second] = a[i].first[j];
				f = true;
				break;
			}
		}
		if (!f) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (auto x : ans) cout << x << ' ';
	cout << '\n';
	return;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}