#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pll pair<ll, ll>

const ll mod1 = 1e9 + 7;
const ll inf = 1e18;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> r(a, b);
    return r(rng);
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> friendComes(n);
    vector<vector<int>> possible(m), whenComes(n);
    int maxVisits = m / 2;
    if (m % 2 == 1) {
        maxVisits++;
    }
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            x--;
            friendComes[x]++;
            possible[i].pb(x);
            whenComes[x].pb(i);
        }
    }
    vector<int> whoPlays(m, -1);
    vector<int> haveFat;
    for (int i = 0; i < n; i++) {
        if (friendComes[i] <= maxVisits) {
            for (auto u : whenComes[i]) {
                if (whoPlays[u] == -1) {
                    whoPlays[u] = i;
                }
            }
        } else {
            haveFat.pb(i);
        }
    }
    vector<int> rest(n, maxVisits);
    for (int i = 0; i < m; i++) {
        if (whoPlays[i] == -1 and possible[i].size() == 1) {
            int f = possible[i].back();
            if (rest[f] == 0) {
                cout << "NO\n";
                return;
            }
            rest[f]--;
            whoPlays[i] = f;
        }
    }
    for (auto f : haveFat) {
        for (auto u : whenComes[f]) {
            if (whoPlays[u] == -1 and rest[f] > 0) {
                rest[f]--;
                whoPlays[u] = f;
            }
        }
    }
    cout << "YES\n";
    vector<int> visits(n);
    for (auto x : whoPlays) {
        visits[x]++;
        cout << x + 1 << " ";
    }
    cout << "\n";
    assert(*max_element(all(visits)) <= maxVisits);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
