﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <cmath>
using namespace std;

struct edge {
	int to, c, f;
	edge() :to(0), c(0), f(0) {}
	edge(int to, int c, int f) :to(to), c(c), f(f) {}
};
const int M = 900000;
edge edges[M];
int cnt = 0;
vector<int>g[200010];
int INF = 1e9;
int nx[200010];
int d[200010];
// исток = 200005
// сток =200006
void addedge(int v, int u, int c) {
	edges[cnt] = edge(u, c, 0);
	g[v].push_back(cnt++);
	edges[cnt] = edge(v, 0, 0);
	g[u].push_back(cnt++);
}

bool bfs(int s, int t, int n) {
	for (int i = 0; i < n; i++)
		d[i] = 1000000;
	d[s] = 0;
	queue<int>q;
	q.push(s);
	while (q.size()) {
		int v = q.front();
		q.pop();
		for (auto c : g[v]) {
			int to = edges[c].to;
			if (edges[c].c == edges[c].f || d[to] <= d[v] + 1)
				continue;
			d[to] = d[v] + 1;
			q.push(to);
		}
	}
	if (d[t] == 1000000)
		return 0;
	return 1;
}

int dfs(int v, int t, int f) {
	if (v == t)
		return f;
	if (f == 0)
		return 0;
	int sum = 0;
	for (; nx[v] < g[v].size(); nx[v]++) {
		int id = g[v][nx[v]];
		int to = edges[id].to;
		if (d[to] != d[v] + 1 || edges[id].c == edges[id].f)
			continue;
		int del = dfs(to, t, min(edges[id].c - edges[id].f, f - sum));
		sum += del;
		edges[id].f += del;
		edges[id ^ 1].f -= del;
		if (sum == f)
			break;
	}
	return sum;
}

int dinic(int s, int t, int n) {
	int mf = 0;
	while (bfs(s, t, n)) {
		for (int i = 0; i < n; i++)
			nx[i] = 0;
		mf += dfs(s, t, INF);
	}
	return mf;
}

void solve() {
	int n, m;
	cin >> n >> m;
	cnt = 0;
	for (int i = 0; i < n+m+2; i++)
		g[i].clear();
	int mx = (m+1) / 2;
	for (int i1 = 0; i1 < m; i1++) {
		int k;
		cin >> k;
		
		addedge(n + i1, n+m+1, 1);
		for (int i = 0; i < k; i++) {
			int a;
			cin >> a;
			a--;
			addedge(a, n + i1, 1);
		}
	}
	for (int i = 0; i < n; i++)
		addedge(n+m, i, mx);
	int ans = dinic(n+m, n+m+1, n+m+2);
	if (ans < m) {
		cout << "NO" << '\n';
		return;
	}
	cout << "YES" << '\n';
	vector<int>res(m);
	for (int i = 0; i < n; i++) {
		for (auto c : g[i]) {
			int to = edges[c].to;
			if (to < n + m && edges[c].f == 1)
				res[to-n] = i;
		}
	}
	for (auto c : res)
		cout << c + 1 << ' ';
	cout << '\n';
}


int main() {
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
	int t;
	cin >> t;
	//t = 1;
	while (t) {
		t--;
		solve();
	}
}