#include <bits/stdc++.h>
#include <ostream>

using ll = long long;
using namespace std;

int n, m;

map<int, int> counts_taken;

bool is_greater(int a, int b) {
    return counts_taken[a] < counts_taken[b];
}

int solve() {
    if (!(cin >> n >> m))
        return 1;
    counts_taken.clear();
    vector<int> answer(m, -1);
    vector<pair<pair<int, int>, vector<int>>> days(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        vector<int> friends(k);
        for (int j = 0; j < k; ++j) {
            cin >> friends[j];
            friends[j]--;
        }
        days[i] = make_pair(make_pair(k, i), friends);
    }
    sort(days.begin(), days.end());
    for (int i = 0; i < m; ++i) {
        sort(days[i].second.begin(), days[i].second.end(), is_greater);
        int taken = days[i].second[0];
        counts_taken[taken]++;
        if (counts_taken[taken] > (m + 1) / 2) {
            cout << "NO\n";
            return 0;
        }
        answer[days[i].first.second] = taken + 1;
    }
    cout << "YES\n";
    for (int i : answer) {
        cout << i << ' ';
    }
    cout << '\n';
    return 0;
}

signed main() {

#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif

    iostream::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1e9;
     cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "--------------------\n";
#endif
    }
}
