#include <iostream>
#include <map>
#include <algorithm>
#include <queue>
#include <set>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <iomanip>
#include <cassert>
#include <bitset>
#include <deque>

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;

mt19937 rnd(time(nullptr));

inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int inf = 1e9 + 1;

struct flow {
    struct edge {
        int a, b, c;
        int flow = 0;
        edge() {}
        edge(int _a, int _b, int _c) : a(_a), b(_b), c(_c) {}
    };
    vector<edge> E;
    int n;
    vector<vector<int> > g;
    flow() {}
    flow(int _n) : n(_n) {
        g.assign(n, vector<int>(0));
        E.clear();
    }

    void insert_edge(int a, int b, int c) {
        g[a].push_back((int) E.size());
        E.push_back(edge(a, b, c));
        g[b].push_back((int) E.size());
        E.push_back(edge(b, a, 0));
    }

    vector<int> d;
    vector<int> usd;
    queue<int> Q;
    bool bfs(int s, int t) {
        d.assign(n, inf);
        usd.assign(n, 0);
        Q.push(s);
        usd[s] = 1;
        d[s] = 0;
        while (!Q.empty()) {
            int from = Q.front();
            Q.pop();
            for (auto u : g[from]) {
                if (!usd[E[u].b] && E[u].c - E[u].flow > 0) {
                    usd[E[u].b] = 1;
                    d[E[u].b] = d[from] + 1;
                    Q.push(E[u].b);
                }
            }
        }
        return usd[t];
    }
    vector<int> path, ind;
    bool dfs(int s, int t) {
        if (d[s] >= d[t]) return (s == t);
        for (; ind[s] < (int) g[s].size(); ++ind[s]) {
            edge &e = E[g[s][ind[s]]];
            if (d[e.b] == d[e.a] + 1 && e.c - e.flow > 0 && dfs(e.b, t)) {
                path.push_back(g[s][ind[s]]);
                return true;
            }
        }
        return false;
    }
    void push() {
        int mf = inf;
        for (auto u : path) {
            mf = min(mf, E[u].c - E[u].flow);
        }
        for (auto u : path) {
            E[u].flow += mf;
            E[u^1].flow -= mf;
        }
    }
    void maxflow(int s, int t) {
        while (bfs(s, t)) {
            ind.assign(n, 0);
            path.clear();
            while (dfs(s, t)) {
                push();
                path.clear();
            }
        }
    }
    int count(int s) {
        int res = 0;
        for (auto i : g[s]) {
            res += E[i].flow;
        }
        return res;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<set<int> > days(m);
    vector<int> cnt(n, 0);
    flow F(n + m + 2);
    int s = n + m, t = n + m + 1;
    for (int i = 0; i < m; ++i) {
        F.insert_edge(s, i, 1);
    }
    for (int i = 0; i < n; ++i) {
        F.insert_edge(m + i, t, (m + 1) / 2);
    }
    vector<vector<int> > g(m, vector<int>(0));
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            x--;
            F.insert_edge(i, m + x, 1);
        }
    }
    F.maxflow(s, t);
    if (F.count(s) != m) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        for (int i = 0; i < m; ++i) {
            for (auto u : F.g[i]) {
                if (F.E[u].flow == 1) {
                    cout << F.E[u].b - m + 1 << ' ';
                    break;
                }
            }
        }
        cout << '\n';
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}