//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse42,avx,bmi,popcnt")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <cstdio>
#include <climits>
#include <cmath>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

struct point
{
	int64_t x, y;
	point operator + (const point& rhs) const
	{
		return {x+rhs.x, y+rhs.y};
	}
	point operator - (const point& rhs) const
	{
		return {x-rhs.x, y-rhs.y};
	}
	int64_t operator * (const point& rhs) const
	{
		return x*rhs.x + y*rhs.y;
	}
	int64_t operator % (const point& rhs) const
	{
		return x*rhs.y - y*rhs.x;
	}
	double dist() const
	{
		return std::hypot(x, y);
	}
};
int64_t gcd(int64_t a, int64_t b)
{
	if(a < 0) a = -a;
	if(b < 0) b = -b;
	if(a == 0 || b == 0) return a + b;
	return gcd(b, a%b);
}
int main()
{
	int t; std::cin >> t;
	while(t --> 0)
	{
		int n, m; std::cin >> n >> m;
		//choose in any way
		//if a friend is used more than m/2 times, exclude it and try again. if at least m/2 da
		std::vector<std::vector<int>> choices(m);
		std::vector<int> init_cts(n);
		for(int i = 0; i < m; i++)
		{
			int k; scanf("%d", &k);
			choices[i].resize(k);
			for(int& x : choices[i]) scanf("%d", &x), x--;
		}
		int maxc = 0, excluded = -1;
		for(int i = 0; i < m; i++)
		{
			init_cts[choices[i][0]]++;
			if(init_cts[choices[i][0]] > maxc)
				maxc = init_cts[choices[i][0]],
				excluded = choices[i][0];
		}
		if(maxc <= (m + 1) / 2)
		{
			printf("YES\n");
			for(int i = 0; i < m; i++)
				printf("%d ", choices[i][0] + 1);
			printf("\n");
			continue;
		}
		//exclude this friend
		std::vector<int> echoice(m, -1);
		for(int i = 0; i < m; i++)
		{
			if(choices[i][0] == excluded && choices[i].size() > 1)
				echoice[i] = choices[i][1];
			if(choices[i][0] != excluded)
				echoice[i] = choices[i][0];
		}
		//count -1s
		int bad = 0;
		for(int i = 0; i < m; i++)
		{
			if(echoice[i] == -1) bad++;
		}
		if(bad > (m + 1) / 2)
		{
			printf("NO\n");
			continue;
		}
		int used = 0;
		//for(int i = 0; i < m; i++)
		//	printf("%d ", echoice[i]+1);
		for(int i = 0; i < m; i++)
		{
			if(echoice[i] == -1)
				echoice[i] = choices[i][0], used++;
		}
		//printf("used=%d\n", used);
		//for(int i = 0; i < m; i++)
		//	printf("%d ", echoice[i]+1);
		//printf("\n");
		for(int i = 0; i < m; i++)
		{
			if(echoice[i] != excluded && choices[i][0] == excluded && used + 1 <= (m + 1) / 2)
				echoice[i] = choices[i][0], used++;
		}
		printf("YES\n");
		for(int i = 0; i < m; i++)
			printf("%d ", echoice[i]+1);
		printf("\n");
	}
}
