#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());



inline void solve() {
    int n, m;
    cin >> n >> m;
    vec<vec<int>> where(n);
    vec<set<int>> days(m);

    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            x--;
            days[i].insert(x);
            where[x].push_back(i);
        }
    }

    set<pair<int, int>> st;
    for (int i = 0; i < n; i++)
        st.insert({len(where[i]), i});

    vec<int> cur_deg(n);
    for (int i = 0; i < n; i++)
        cur_deg[i] = len(where[i]);

    vec<char> used(m);
    int mx = (m + 1) / 2;

    vec<int> ans(m);
    vec<char> in_ans(n);
    while (len(st)) {
        auto [deg, v] = *st.begin();
        st.erase(st.begin());
        in_ans[v] = 1;

        dbg(v, deg);

        sort(all(where[v]), [&](int a, int b) {
            if (used[a])
                return false;
            if (used[b])
                return true;

            return len(days[a]) < len(days[b]);
        });

        for (int i = 0; i < deg; i++) {
            int d = where[v][i];
            assert(!used[d]);
            if (i < mx) {
                used[d] = 1;
                ans[d] = v;
                for (auto u : days[d])
                    if (!in_ans[u]) {
                        st.erase({cur_deg[u], u});
                        cur_deg[u]--;
                        st.insert({cur_deg[u], u});
                    }
            } else {
                days[d].erase(v);
            }
        }
    }

    if (find(all(used), 0) != used.end()) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    for (auto x : ans)
        cout << x + 1 << ' ';
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
