#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define P pair
typedef P<ll, ll> Pll;
typedef P<ld, ld> Pld;
typedef P<string, string> Pss;

#define all(a) a.begin(), a.end()
#define len(a) (ll)(a.size())

#define yes "YES\n"
#define no "NO\n"

struct SegmentTree{
	vector < ll > tree;
	vector < ll > a;

	SegmentTree(vector<ll> _a){
		this->tree.assign(len(_a)*4, 0);
		this->a = _a;

		build(1, 0, len(_a)-1);
	}

	void build(ll node, ll l, ll r){
		if(l == r){
			tree[node] = a[l];
			return;
		}

		ll m = (l + r) / 2;
		build(node*2, l, m);
		build(node*2+1, m+1, r);

		tree[node] = tree[node*2] + tree[node*2+1];
	}

	ll get(ll node, ll _l, ll _r, ll l, ll r){
		if(_l > r or _r < l)
			return 0;

		if(l <= _l and _r <= r)
			return tree[node];
		

		ll m = (_l + _r) / 2;
		return get(node*2, _l, m, l, r) + get(node*2+1, m+1, _r, l, r);
	}
};

void solve(){
	ll n, m;
	cin >> n >> m;
	vector < vector < ll > > day(m);
	for(int i = 0; i < m; ++i){
		ll k;
		cin >> k;
		day[i].assign(k, 0);

		for(int j = 0; j < k; ++j){
			cin >> day[i][j];
			--day[i][j];
		}
		sort(all(day[i]));
	}
	vector < ll > ans(m, 0);
	vector < ll > frend(n, 0);
	vector < bool > used(m, 0);

	// cout << endl << endl;;
	for(int i = 0; i < m; ++i){
		if(len(day[i]) == 1){
			used[i] = true;
			frend[day[i][0]] += 1;
			ans[i] = day[i][0]; 
		}
	}

	for(int i = 0; i < n; ++i){
		if(frend[i] > (ll)((m + 1) / 2)){
			cout << no;
			return;
		}
	}

	for(int i = 0; i < m; ++i){
		if(used[i]) continue;
		ll id = day[i][0];
		for(auto j : day[i]){
			// cout << j << ' ';
			if(frend[j] < frend[id])
				id = j;
		}
		ans[i] = id;
		// cout << endl;
		++frend[id];
		used[i] = true;
	}

	for(int i = 0; i < n; ++i){
		if(frend[i] > (ll)((m + 1) / 2)){
			cout << no;
			return;
		}
	}
	cout << yes;
	for(auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
	return;
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	cin >> t;
	while(t--){
		solve();
	}
	return 0;
}