#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;

constexpr ll inf = 1e18;

void solve();

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);
  cerr.setf(ios::fixed);
  cerr.precision(5);
  ll start = clock();
  ll case_count = 1;
  cin >> case_count;
  while (case_count--) solve();
  cerr << ld(clock() - start) / CLOCKS_PER_SEC << endl;
}

// ---------


void solve() {
  ll n, m;
  cin >> n >> m;
  vector<vector<ll>> free(m);
  for (int i = 0; i < m; ++i) {
    ll sz;
    cin >> sz;
    free[i].resize(sz);
    for (int j = 0; j < sz; ++j) {
      cin >> free[i][j];
      --free[i][j];
    }
  }

  vector<ll> ans(m, -1);
  vector<ll> game(n);
  for (int i = 0; i < m; ++i) {
    if (free[i].size() > 1) continue;
    ans[i] = free[i][0];
    ++game[ans[i]];
    if (game[ans[i]] > (m + 1) / 2) {
      cout << "NO" << endl;
      return;
    }
  }
  for (int i = 0; i < m; ++i) {
    if (free[i].size() == 1) continue;
    ans[i] = free[i][0];
    ++game[ans[i]];
    if (game[ans[i]] > (m + 1) / 2) {
      --game[ans[i]];
      ans[i] = free[i][1];
    }
    if (game[ans[i]] > (m + 1) / 2) {
      abort();
    }
  }
  cout << "YES" << endl;
  for (auto e: ans) {
    cout << e + 1 << ' ';
  }
  cout << endl;
}