#include <iostream>
#include <algorithm>
#include <cmath>
#include <array>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>

using namespace std;

#define int long long		//!!!

const int INF = 4e18;
const int MOD = 1e9 + 7;
const int N = 5e5 + 10;
const int M = 5e3 + 10;
const int T = 1e6 + 10;

struct DSU {
	struct Node {
		int pr;
		int sz;
		Node(int pr): pr(pr), sz(1) {}
		Node() {}
	};

	int n;
	vector <Node> p;
	
	DSU(int n) : n(n) {
		for (int i = 0; i < n; i++)
			p[i] = { i };
	}

	int root(int v) {
		return p[v].pr == v ? v : p[v].pr = root(p[v].pr);
	}

	void unite(int u, int v) {
		u = root(u);
		v = root(v);
		if (p[u].sz > p[v].sz)
			swap(u, v);
		p[v].sz += p[u].sz;
		p[u].pr = v;
	}

	int size(int x) {
		return p[root(x)].sz;
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int ttt = 1;
	cin >> ttt;
	while (ttt--) {
		int n, m;
		cin >> n >> m;
		vector <pair <vector <int>, int>> a(m);
		for (int i = 0; i < m; i++) {
			int k;
			cin >> k;
			a[i].first.resize(k);
			for (int& j : a[i].first)
				cin >> j, j--;
			a[i].second = i;
		}
		sort(a.begin(), a.end(), [](const auto& a, const auto& b) { 
			return a.first.size() < b.first.size(); 
			});

		vector <int> cnt(n), ans(m, -1);
		for (int i = 0; i < m; i++) {
			int mn = INF, k;
			for (int j : a[i].first)
				if (cnt[j] < mn)
					tie(mn, k) = { cnt[j], j };
			if (mn + 1 > (m + 1) / 2)
				break;
			ans[a[i].second] = k;
			cnt[k]++;
		}

		if (find(ans.begin(), ans.end(), -1) != ans.end())
			cout << "NO\n";
		else {
			cout << "YES\n";
			for (int i : ans)
				cout << i + 1 << ' ';
			cout << '\n';
		}
	}
	return 0;
}
