#include <bits/stdc++.h>

using namespace std;
using ii = pair<int, int>;
using ll = long long;

const ll inf = (ll) 1e17;

#define fi first
#define se second

struct point {
	double y, x;
	void rotate(point A, double ang) {
		y -= A.y;
		x -= A.x;

		double ny = y * cos(ang) + x * sin(ang);
		double nx = x * cos(ang) - y * sin(ang);

		y = ny + A.y;
		x = nx + A.x;
	}
};

struct line {
	double a, b, c;
	void init(point A, point B) {
		a = B.y - A.y;
		b = A.x - B.x;
		c = B.x * A.y - A.x * B.y;
	}
	void print() {
		printf("x * %f + y * %f + %f = 0\n", a, b, c);
	}
};

struct node {
	vector<ll> t;
	vector<ll> sm;
	vector<bool> oper;
	int size;
	void init(int n) {
		size = 1;
		while(size <= n)
			size *= 2;
		t = sm = vector<ll>(size * 2 - 1, 0);
		oper = vector<bool>(size * 2 - 1, 0);
	}
	void relax(int tl, int tr, int v) {
		if(tl == tr || !oper[ v ])
			return;
		oper[ v ] = false;

		int vl = 2 * v + 1;
		int vr = 2 * v + 2;
		ll x = sm[ v ];

		oper[ vl ] = oper[ vr ] = true;
		sm[ vl ] += x;
		sm[ vr ] += x;
		t[ vl ] += x;
		t[ vr ] += x;

		sm[ v ] = 0;
	}
	void add(int l, int r, int tl, int tr, int v, int x) {
		if(tr < l || r < tl)
			return;
		if(l <= tl && tr <= r) {
			sm[ x ] += v;
			t[ x ] += v;
			oper[ x ] = true;
			return;
		}
		relax(tl, tr, x);

		int mid = (tl + tr) / 2;
		add(l, r, tl, mid, v, 2 * x + 1);
		add(l, r, mid + 1, tr, v, 2 * x + 2);

		t[ x ] = max(t[ 2 * x + 1 ], t[ 2 * x + 2 ]); // MAX
	}
	ll get(int l, int r, int tl, int tr, int v) {
		if(tr < l || r < tl)
			return -inf;
		if(l <= tl && tr <= r)
			return t[ v ];
		relax(tl, tr, v);

		int mid = (tl + tr) / 2;
		return max(get(l, r, tl, mid, 2 * v + 1), get(l, r, mid + 1, tr, 2 * v + 2)); // MAX
	}
};

const int N = 311111;
int n, m;
vector<pair<vector<int>, int>> d;
int ans[ N ];
int c[ N ];

bool cmp(const pair<vector<int>, int> &a, const pair<vector<int>, int> &b) {
	return a.fi.size() < b.fi.size();
}

void read() {
	scanf("%d%d", &n, &m);
	for(int i = 0, k; i < m; i++) {
		scanf("%d", &k);
		vector<int> e;
		for(int j = 0, x; j < k; j++) {
			scanf("%d", &x);
			e.push_back(x);
		}
		sort(e.begin(), e.end());
		d.push_back({e, i});
	}
	sort(d.begin(), d.end(), cmp);
}

void solve() {
	d.clear();
	read();
	fill(ans, ans + m, -1);
	fill(c, c + n + 1, 0);

	for(int i = 0; i < m; i++) {
		int x = d[ i ].fi.back();
		for(int j = 0; j < (int) d[ i ].fi.size(); j++) {
			int y = d[ i ].fi[ j ];
			if(c[ y ] < c[ x ] && c[ y ] < (m + 1) / 2)
				x = y;
		}

		if(c[ x ] < (m + 1) / 2) {
			ans[ d[ i ].se ] = x;
			c[ x ]++;
		}
	}

	if(count(ans, ans + m, -1) != 0)
		printf("NO\n");
	else {
		printf("YES\n");
		for(int i = 0; i < m; i++)
			printf("%d ", ans[ i ]);
		printf("\n");
	}
}

int main() {
	int t = 1;
	scanf("%d", &t);
	while(t--)
		solve();
}