/*
 * PRAGMA MORGEN
 * PRAGMA KADILLAK
 * PRAGMA SLAVA MARLOW
 * PRAGMA AVTOMAT
 * PRAGMA MERIN
 * PRAGMA KRISTAL
 * PRAGMA MOET
 * PRAGMA YUNG HEFNER
 */

#include <bits/stdc++.h>

#define pll pair<ll, ll>
#define x first
#define y second

#define ff first
#define ss second

/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
/**/
using namespace std;

typedef long long int ll;

mt19937 gen(1337);

ll n, m;

struct dt{
    dt *l, *r;
    ll y;
    ll sz;
    ll val;

    dt(){
        y = gen();
        sz = 1;
        l = r = nullptr;
    }

    dt(ll v){
        y = gen();
        sz = 1;
        l = r = nullptr;
        val = v;
    }
};

ll get_sz(dt * a){
    if(a == nullptr) return 0;
    return a->sz;
}

dt* merge(dt *l, dt *r){
    if(l == nullptr) return r;
    if(r == nullptr) return l;

    if(l->y > r->y){
        dt *a = merge(l->r, r);
        l->r = a;
        l->sz = get_sz(l->l) + 1 + get_sz(l->r);
        return l;
    }else {
        dt *a = merge(l, r->l);
        r->l = a;
        r->sz = get_sz(r->l) + 1 + get_sz(r->r);
        return r;
    }
}

pair<dt*, dt*> split(dt *a, ll i){
    if (a == nullptr) return {nullptr, nullptr};
    ll ind = get_sz(a->l);
    if(ind < i){
        pair<dt *, dt*> kek = split(a->r, i - ind - 1);
        a->r = kek.first;
        a->sz = get_sz(a->l) + 1 + get_sz(a->r);
        return {a, kek.second};
    }else{
        pair<dt*, dt*> kek = split(a->l, i);
        a->l = kek.second;
        a->sz = get_sz(a->l) + 1 + get_sz(a->r);
        return {kek.first, a};
    }
}

const ll INF = 1e12;

void solve(){
    ll t;
    cin >> t;
    for (int aafd = 0; aafd < t; ++aafd) {
        cin >> n >> m;
        map<ll, ll> mp;
        vector<vector<ll>> v(m);
        for (int i = 0; i < m; ++i) {
            ll k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                ll x;
                cin >> x;
                v[i].push_back(x);
                ++mp[x];
            }
        }
        ll mx = 0;
        ll color = 0;
        for(pair<ll, ll> p: mp){
            if(p.second > mx){
                mx = p.second;
                color = p.first;
            }
        }

        ll only = 0;
        for (int i = 0; i < m; ++i) {
            if(v[i][0] == color && v[i].size() == 1) ++only;
        }
        ll needed = min((m + 1) / 2, mx);
        needed -= only;
        if(needed < 0){
            cout << "NO\n";
            continue;
        }
        vector<ll> ans;
        for (int i = 0; i < m; ++i) {
            if(v[i].size() == 1 && v[i][0] == color){
                //fill only
                ans.push_back(color);
                continue;
            }else if(needed > 0) {

                bool found = false;
                for (int j = 0; j < v[i].size(); ++j) {
                    if (v[i][j] == color) {
                        --needed;
                        found = true;
                        ans.push_back(color);
                        break;
                    }
                }
                if(!found) ans.push_back(v[i][0]);
            }else{
                for (int j = 0; j < v[i].size(); ++j) {
                    if (v[i][j] != color) {
                        ans.push_back(v[i][j]);
                        break;
                    }
                }
            }
        }

        cout << "YES\n";
        for(ll e: ans) cout << e << " ";
        cout << "\n";
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    /*
    freopen("input.txt", "r", stdin);
    /**/
    solve();
}