﻿#define ll long long

#include<iostream>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<string>

using namespace std;

struct el {
    ll i = 0;
    vector<ll> a = {};
    const bool operator <(const el& e) const {
        return a.size() < e.a.size();
    }
};

/////////////////// SEGMENT_TREE //////////////////////
/*

void build(vector<ll> &tree, vector<ll> &a, ll now, ll l, ll r) {
    if (l == r) {
        tree[now] = a[l];
        return;
    }
    ll mid = (r + l) / 2;
    build(tree, a, now * 2 + 1, l, mid);
    build(tree, a, now * 2 + 2, mid + 1, r);
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

void change(vector<ll>& tree, ll now, ll l, ll r, ll pos, ll x) {
    if (l == r) {
        tree[l] = x;
        return;
    }
    ll mid = (l + r) / 2;
    if (pos <= mid) {
        change(tree, now * 2 + 1, l, mid, pos, x);
    }
    else {
        change(tree, now * 2 + 2, mid + 1, r, pos, x);
    }
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

ll qw(vector<ll>& tree, ll now, ll l, ll r, ll ql, ll qr) {
    ql = max(ql, l);
    qr = min(qr, r);
    if (ql > qr) {
        return -1e9;
    }
    if (l == ql && r == qr) {
        return tree[now];
    }
    ll mid = (l + r) / 2;
    return max(
        qw(tree, now * 2 + 1, l, mid, ql, qr),
        qw(tree, now * 2 + 2, mid + 1, r, ql, qr));
}

*/
/////////////////// SEGMENT_TREE //////////////////////

vector<ll> cnt;

bool cmp(ll& a, ll& b) {
    return cnt[a] < cnt[b];
}

void true_main() {
    ll n, m;
    cin >> m >> n;
    ll pred = (n + 1) / 2;
    vector<el> a(n);
    cnt.resize(m, 0);
    vector<ll> now(m, 0);
    for (int i = 0; i < n; i++) {
        ll fw;
        cin >> fw;
        for (int j = 0; j < fw; j++) {
            ll qw;
            cin >> qw;
            qw--;
            cnt[qw]++;
            a[i].a.push_back(qw);
        }
        a[i].i = i;
    }
    for (int i = 0; i < n; i++) {
        sort(a[i].a.begin(), a[i].a.end(), cmp);
    }
    sort(a.begin(), a.end());
    vector<ll> ans(n, 0);
    for (int i = 0; i < n; i++) {
        ll j = 0;
        while (j < a[i].a.size()) {
            if (now[a[i].a[j]] < pred) {
                now[a[i].a[j]]++;
                ans[a[i].i] = a[i].a[j] + 1;
                break;
            }
            j++;
        }
        if (j == a[i].a.size()) {
            cout << "NO";
            return;
        }
    }
    cout << "YES\n";
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    ll t = 1;
    cin >> t;
    
    while (t--) {
        true_main();
        cout << "\n";
    }
}