#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <random>
#include <cassert>
#include <iomanip>
#include <algorithm>
#include <bitset>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 1

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 9;
const int INF1 = 2e18;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*---------------------------------------------------------------*/

bool cmp(const pair<vector<int>, int> &a, const pair<vector<int>, int> &b) {
    return a.first.size() < b.first.size();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<vector<int>, int>> day(m);
    vector<vector<int>> cntf(n);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int cur;
            cin >> cur;
            --cur;
            day[i].first.push_back(cur);
            cntf[cur].push_back(i);
        }
        day[i].second = i;
    }
    vector<int> ans(m);
    vector<bool> used(m);
    int m2 = (m + 1) / 2;
    for (int i = 0; i < n; ++i)
        if (cntf[i].size() <= m2)
            for (int j : cntf[i])
                if (!used[j]) {
                    ans[j] = i;
                    used[j] = true;
                }
    sort(all(day), cmp);
    vector<int> lim(n, m2);
    for (const pair<vector<int>, int> &i : day) {
        if (used[i.second])
            continue;
        for (int j : i.first)
            if (lim[j]) {
                --lim[j];
                used[i.second] = true;
                ans[i.second] = j;
                break;
            }
    }
    bool ok = true;
    for (int i = 0; i < m; ++i)
        ok &= used[i];
    if (ok) {
        cout << "YES\n";
        for (int i : ans)
            cout << i + 1 << ' ';
        cout << '\n';
    } else {
        cout << "NO\n";
    }
}