#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <tuple>

//#define int long long
#define ll long long
#define ld long double
#define accuracy(x) fixed << setprecision(x)

const int INF = (int)1e9;
const long long LINF = (long long)1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1.0);

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void file_in(string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

ld my_difftime(clock_t start, clock_t end)
{
    return (ld)(end - start) / ((ld)CLOCKS_PER_SEC / 1000);
}

void sleep(ld milliseconds)
{
    clock_t start = clock();
    for (clock_t end = clock(); my_difftime(start, end) < milliseconds; end = clock()) {}
}

struct Node
{
    int id;
    vector<int> values;

    Node()
    {
        id = -1;
    }
    Node(int id, int size) : id(id)
    {
        values.resize(size);
    }
};

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<Node> nodes(m);
    for (int i = 0; i < m; ++i)
    {
        int k;
        cin >> k;
        nodes[i] = Node(i, k);
        for (int j = 0; j < k; ++j)
        {
            cin >> nodes[i].values[j];
        }
    }
    auto cmp = [](const Node& a, const Node& b)
    {
        return a.values.size() < b.values.size();
    };
    sort(nodes.begin(), nodes.end(), cmp);

    int target = ceil((double)m / 2);
    vector<int> count(n + 1);
    vector<int> choice(m, -1);
    for (Node& node : nodes)
    {
        int min_value, min_index;
        min_value = min_index = INF;
        for (int friend_id : node.values)
        {
            if (count[friend_id] < min_value)
            {
                min_value = count[friend_id];
                min_index = friend_id;
            }
        }
        choice[node.id] = min_index;
        ++count[min_index];
        if (count[min_index] > target)
        {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (int friend_id : choice)
    {
        cout << friend_id << ' ';
    }
    cout << '\n';
}


signed main()
{
#ifndef LOCAL
    fast_io();
#else
    clock_t start = clock();
#endif

    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve();
    }

#ifdef LOCAL
    cerr << "TIME: " << accuracy(2) << my_difftime(start, clock()) << '\n';
#endif

}