#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>

#include "ext/rope"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
#include <ctime>

#ifndef LOCAL_BUILD
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#endif

namespace {
    using namespace std;
    using namespace __gnu_cxx;
    using namespace __gnu_pbds;
    
    typedef long long ll;
    typedef long double ld;
    
    typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update, allocator<char>> ordered_set;
    
    const int MOD = 1e9 + 7;
    const int INF = 1e9 + 33;
    const ll LLINF = 1e18 + 11;
    const ld EPS = 1e-8;

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
    
    template<typename T>
    istream& operator>>(istream& in, vector<T>& r) {
        for (auto& e : r)
            cin >> e;
    }
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {
        cin >> p.first >> p.second;
    }
    
    template<typename T>
    ostream& operator<<(ostream& out, vector<T>& r) {
        for (auto& e : r)
            cout << e << ' ';
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("test.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    speed;
    int t; cin >> t; while (t--)
    solve();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<deque<int>> friends(n);
    vector<vector<int>> days(m);
    vector<int> maxi(n, 0);
    vector<int> mini(n, 0);
    for (int i = 0; i < m; i++) {
        int sz;
        cin >> sz;
        days[i] = vector<int>(sz);
        cin >> days[i];
        if (sz == 1) {
            mini[days[i][0] - 1]++;
            maxi[days[i][0] - 1]++;
            friends[days[i][0] - 1].push_front(i);
        } else {
            for (int e : days[i]) {
                friends[e - 1].push_back(i);
                maxi[e - 1]++;
            }
        }
    }
    bool allLess = true;
    int mid = ceil(ld(m) / 2);
    for (int i = 0; i < n; i++) {
        if (maxi[i] > mid)
            allLess = false;
        if (mini[i] <= mid && maxi[i] >= mid) {
            int cnt = 0;
            vector<int> ans(m, -1);
            while (cnt < mid) {
                ans[friends[i][cnt]] = i + 1;
                cnt++;
            }
            for (int day = 0; day < m; day++) {
                if (ans[day] != -1)
                    continue;
                if (days[day][0] == i + 1)
                    ans[day] = days[day][1];
                else
                    ans[day] = days[day][0];
            }
            cout << "YES\n";
            for (int q = 0; q < m; q++)
                cout << ans[q] << ' ';
            cout << '\n';
            return;
        }
    }
    if (!allLess) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    for (int day = 0; day < m; day++) {
        cout << days[day][0] << ' ';
    }
    cout << '\n';
}