#include <bits/stdc++.h>

using namespace std;

#define endl '\n'

int gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

struct segtree_gcd {
    vector<int> t;
    segtree_gcd(int n) {
        t.resize(5 * n);
    }
    void upd(int v) {
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    void build(int v, int vl, int vr, vector<int>& a) {
        //cout << v << " " << vl << " " << vr << " " << t[v] << endl;
        if (vl == vr - 1) {
            //cout << gcd(a[vl], a[(vl + 1) % a.size()]) << " " << t[v] << endl;
            t[v] = (gcd(a[vl], a[(vl + 1) % a.size()]) == 1) ? 1 : 0;
            return;
        }
        int vm = (vl + vr) / 2;
        build(2 * v, vl, vm, a);
        build(2 * v + 1, vm, vr, a);
        upd(v);
    }
    int get_kth(int v, int vl, int vr, int k) {
        //if (vl == vr) return -1;
        if (vl == vr - 1) {
            //if (t[v] == 0) return -1;
            return vl;
        }
        int vm = (vl + vr) / 2;
        if (k <= t[2 * v]) {
            return get_kth(2 * v, vl, vm, k);
        } else {
            return get_kth(2 * v + 1, vm, vr, k - t[2 * v]);
        }
    }
    int get_summ(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l) return 0;
        if (vl >= l && vr <= r) return t[v];
        int vm = (vl + vr) / 2;
        return get_summ(2 * v, vl, vm, l, r) + get_summ(2 * v + 1, vm, vr, l, r);
    }
    int get_kth_otr(int v, int vl, int vr, int l, int r, int k) {
        if (get_summ(v, vl, vr, l, r) < k) {
            return -1;
        }
        return get_kth(v, vl, vr, get_summ(v, vl, vr, 0, l) + k);
    }
    void change(int v, int vl, int vr, int pos, int num) {
        if (vl == vr - 1) {
            t[v] = num;
            return;
        }
        int vm = (vl + vr) / 2;
        if (pos < vm) {
            change(2 * v, vl, vm, pos, num);
        } else {
            change(2 * v + 1, vm, vr, pos, num);
        }
        upd(v);
    }
    void out(int v, int vl, int vr) {
        cout << v << " " << vl << " " << vr << " " << t[v] << endl;
        if (vl == vr - 1) {
            return;
        }
        int vm = (vl + vr) / 2;
        out(2 * v, vl, vm);
        out(2 * v + 1, vm, vr);
    }
};

struct segtree_in {
    vector<int> t;
    segtree_in(int n) {
        t.resize(5 * n);
    }
    void upd(int v) {
        t[v] = t[2 * v] + t[2 * v + 1];
    }
    void build(int v, int vl, int vr, vector<int>& a) {
        if (vl == vr - 1) {
            t[v] = 1;
            return;
        }
        int vm = (vl + vr) / 2;
        build(2 * v, vl, vm, a);
        build(2 * v + 1, vm, vr, a);
        upd(v);
    }
    int get_kth(int v, int vl, int vr, int k) {
        //if (vl == vr) return -1;
        if (vl == vr - 1) {
            //if (t[v] == 0) return -1;
            return vl;
        }
        int vm = (vl + vr) / 2;
        if (k <= t[2 * v]) {
            return get_kth(2 * v, vl, vm, k);
        } else {
            return get_kth(2 * v + 1, vm, vr, k - t[2 * v]);
        }
    }
    int get_summ(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l) return 0;
        if (vl >= l && vr <= r) return t[v];
        int vm = (vl + vr) / 2;
        return get_summ(2 * v, vl, vm, l, r) + get_summ(2 * v + 1, vm, vr, l, r);
    }
    int get_kth_otr(int v, int vl, int vr, int l, int r, int k) {
        if (get_summ(v, vl, vr, l, r) < k) {
            return -1;
        }
        return get_kth(v, vl, vr, get_summ(v, vl, vr, 0, l) + k);
    }
    void change(int v, int vl, int vr, int pos, int num) {
        if (vl == vr - 1) {
            t[v] = num;
            return;
        }
        int vm = (vl + vr) / 2;
        if (pos < vm) {
            change(2 * v, vl, vm, pos, num);
        } else {
            change(2 * v + 1, vm, vr, pos, num);
        }
        upd(v);
    }
    void out(int v, int vl, int vr) {
        cout << v << " " << vl << " " << vr << " " << t[v] << endl;
        if (vl == vr - 1) {
            return;
        }
        int vm = (vl + vr) / 2;
        out(2 * v, vl, vm);
        out(2 * v + 1, vm, vr);
    }
};

void solve() {
    //cout << gcd(5, 9) << endl;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < a.size(); i++) {
        cin >> a[i];
    }
    segtree_gcd tgcd = segtree_gcd(n);
    segtree_in tin = segtree_in(n);
    tgcd.build(1, 0, n, a);
    tin.build(1, 0, n, a);
//    cout << "gcd" << endl;
//    tgcd.out(1, 0, n);
//    cout << "in" << endl;
//    tin.out(1, 0, n);
    int pos = 0;
    //cout << "here" << endl;
    vector<int> ans;
    while (true) {
        int x = tgcd.get_kth_otr(1, 0, n, pos, n, 1);
        if (x == -1) {
            x = tgcd.get_kth_otr(1, 0, n, 0, pos, 1);
            if (x == -1) {
                break;
            }
        }
        //cout << x << " ";
        int next = tin.get_kth_otr(1, 0, n, x + 1, n, 1);
        if (next == -1) {
            next = tin.get_kth_otr(1, 0, n, 0, x, 1);
            if (next == -1) {
                break;
            }
        }
        //cout << next << " ";
        int nnext = tin.get_kth_otr(1, 0, n, next + 1, n, 1);
        if (nnext == -1) {
            nnext = tin.get_kth_otr(1, 0, n, 0, next, 1);
            if (nnext == -1) {
                break;
            }
        }
        //cout << nnext << endl;
        ans.push_back(next);
        tin.change(1, 0, n, next, 0);
        tgcd.change(1, 0, n, next, 0);
        if (gcd(a[x], a[nnext]) == 1) {
            tgcd.change(1, 0, n, x, 1);
        } else {
            tgcd.change(1, 0, n, x, 0);
        }
        pos = nnext;
//        cout << "gcd" << endl;
//        tgcd.out(1, 0, n);
//        cout << "in" << endl;
//        tin.out(1, 0, n);
    }
    if (a[tin.get_kth(1, 0, n, 1)] == 1) {
        ans.push_back(tin.get_kth(1, 0, n, 1));
    }
    cout << ans.size() << " ";
    for (int i : ans) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}
