#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <cmath>
#include <assert.h>
#include <queue>
#include <cstring>
#include <bitset>
#include <random>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define next next288
#define left left228
#define right right228

const int N = 100 * 1000 + 228;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int n;
int a[N];
int nxt[N];
set<int> s;

void solve() {
    cin >> n;

    s.clear();
    for (int i = 1; i <= n; ++i) {
        nxt[i] = i % n + 1;
    }

    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        if (gcd(a[i], a[nxt[i]]) == 1) {
            s.insert(i);
        }
    }
    vector<int> to_delete;
    int lb = 1;
    while (!s.empty()) {
        int i = -1;
        auto it = s.lower_bound(lb);
        if (it != s.end()) {
            i = *it;
        } else {
            i = *s.begin();
        }
        s.erase(i);

        // i -> nxt[i]  gcd(a[i], a[nxt[i]]) = 1

        to_delete.push_back(nxt[i]);

        if (i == nxt[i]) {
            break;
        }

        int nx = nxt[i];
        int nnx = nxt[nxt[i]];

        if (gcd(a[nx], a[nnx]) == 1) {
            s.erase(nx);
        }

        nxt[i] = nnx;

        if (gcd(a[i], a[nxt[i]]) == 1) {
            s.insert(i);
            lb = nxt[i];
        }
    }
    cout << to_delete.size() << " ";
    for (int x : to_delete) {
        cout << x << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}