#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T>
void operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
}

template<typename T>
void operator<<(ostream &os, pair<T, T> &v) {
    os << v.first << ' ' << v.second;
}

#define pb push_back
#define all(a) a.begin(), a.end()
#define sqr(a) ((a) * (a))
#define nl '\n'
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(a) a.size()

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pair<int, int>> vpi;
typedef long long ll;
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(10);
}

const int MAXN = 1e5 + 10;
const int MAXE = 1e5 + 10;
const int K = 100 + 5;

// #define int ll

int gcd(int a, int b) {
    while (a && b) {
        if (a > b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a + b;
}

int tree[4 * MAXN], tree1[4 * MAXN];

void Build(int *t, int v, int tl, int tr, int val) {
    if (tl == tr) {
        t[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    Build(t, v * 2, tl, tm, val);
    Build(t, v * 2 + 1, tm + 1, tr, val);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int GetSum(int *t, int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return 0;
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return GetSum(t, v * 2, tl, tm, l, min(r, tm)) +
           GetSum(t, v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

void Upd(int *t, int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        Upd(t, v * 2, tl, tm, pos, val);
    } else {
        Upd(t, v * 2 + 1, tm + 1, tr, pos, val);
    }
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int n;

int GetNext(int *t, int ind) {
    int s1 = 0;
    if (ind >= 0) {
        s1 = GetSum(t, 1, 0, n - 1, 0, ind);
    }
    int l, r;
    if (GetSum(t, 1, 0, n - 1, 0, n - 1) > s1) {
        l = ind, r = n - 1;
    } else {
        s1 = 0;
        l = -1, r = ind - 1;
    }
    while (r - l > 1) {
        int x = (l + r) / 2;
        if (GetSum(t, 1, 0, n - 1, 0, x) == s1) {
            l = x;
        } else {
            r = x;
        }
    }
    return r;
}

void Solve() {
    cin >> n;
    Build(tree, 1, 0, n - 1, 1);
    Build(tree1, 1, 0, n - 1, 0);
    vi a(n);
    cin >> a;
    forn (i, n) {
        if (gcd(a[i], a[(i + 1) % n]) == 1) {
            Upd(tree1, 1, 0, n - 1, i, 1);
        }
    }
    vi ans;
    int last = -1;
    while (sz(ans) + 1 < n && GetSum(tree1, 1, 0, n - 1, 0, n - 1)) {
        auto ind = GetNext(tree1, last);
        Upd(tree1, 1, 0, n - 1, ind, 0);
        if (GetSum(tree, 1, 0, n - 1, ind, ind) == 0) {
            continue;
        }
        int r = GetNext(tree, ind);
        ans.pb(r + 1);
        Upd(tree, 1, 0, n - 1, r, 0);
        Upd(tree1, 1, 0, n - 1, r, 0);
        if (sz(ans) + 1 == n) {
            break;
        }
        int rr = GetNext(tree, r);
        last = rr - 1;
        if (gcd(a[ind], a[rr]) == 1) {
            Upd(tree1, 1, 0, n - 1, ind, 1);
        }
    }
    if (sz(ans) + 1 == n) {
        forn (i, n) {
            if (GetSum(tree, 1, 0, n - 1, i, i)) {
                if (a[i] == 1) {
                    ans.pb(i + 1);
                    break;
                }
            }
        }
    }
    cout << sz(ans) << ' ';
    cout << ans;
    cout << nl;
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    while (t--) {
        Solve();
    }
    return 0;
}