#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <list>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>
#include <numeric>
#include <random>
/*
#pragma GCC optimise("Ofast,O2,O3")
*/
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n;
        cin >> n;
        vector<int> A(n);
        vector<deque<int>> D(n);
        vector<int> next(n), prev(n);
        for (int i = 0; i < n; ++i) {
            cin >> A[i];
            D[i].push_back(i);
            next[i] = (i + 1) % n;
            prev[i] = (i - 1 + n) % n;
        }
        //
        int i = 0;
        vector<int> res;
        while (true) {
            if (next[i] == i) {
                break;
            }
            int j = next[i];
            int a = A[D[i].back()];
            int b = A[D[j].front()];
            if (gcd(a, b) == 1) {
                res.push_back(D[j].front());
                if (D[j].size() == 1) {
                    next[i] = next[j];
                    prev[next[i]] = i;
                } else {
                    D[j].pop_front();
                }
                i = next[i];
            } else {
                if (D[i].size() >= D[j].size()) {
                    next[i] = next[j];
                    prev[next[i]] = i;
                    for (int el : D[j]) {
                        D[i].push_back(el);
                    }
                } else {
                    prev[j] = prev[i];
                    next[prev[j]] = j;
                    for (int z = (int)D[i].size() - 1; z >= 0; --z) {
                        D[j].push_front(D[i][z]);
                    }
                    i = j;
                }
            }
        }
        //
        while (!D[i].empty()) {
            int a = A[D[i].back()];
            int b = A[D[i].front()];
            if (gcd(a, b) != 1) {
                break;
            }
            res.push_back(D[i].front());
            D[i].pop_front();
        }
        cout << res.size() << " ";
        for (int el : res) {
            cout << el + 1 << " ";
        }
        cout << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}
