#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<utility>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<climits>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<random>
#include <queue>
using namespace std;
#define int long long
mt19937 azino(777);
int gcd(int a, int b) {
	int r;
	while (b != 0) {
		r = a % b;
		a = b;
		b = r;
	}
	return a;
}
struct fenwick {
	vector<int> f;
	int n;
	void add(int i, int val) {
		for (; i < n; i |= (i + 1)) f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i) {
			ans += f[i];
		}
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
	fenwick(vector<int> a) {
		n = a.size();
		f.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			add(i, a[i]);
		}
	}
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
};
void solve() {
	int n;
	cin >> n;
	queue<int> q;
	vector<int> a(n), next(n), prev(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		next[i] = i + 1;
		if (i == n - 1) next[i] = 0;
		q.push(i);
	}
	vector<bool> used(n, false);
	vector<int> ans;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (used[v]) continue;
		if (used[next[v]]) {
			next[v] = next[next[v]];
			continue;
		}
		if (gcd(a[v], a[next[v]]) == 1) {
			used[next[v]] = true;
			ans.push_back(next[v]);
			next[v] = next[next[v]];
			q.push(v);
		}
	}
	cout << ans.size() << ' ';
	for (auto x : ans) cout << x + 1 << ' ';
	cout << '\n';
	return;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}