#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <cstring>
#include <sstream>
#include <functional>
#include <unordered_set>
#include <array>
#include <deque>
#include <chrono>
#include <random>

#define err(x) {cerr << "["#x"]  " << (x) << '\n';}
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << (___) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << ((x)[___]) << ", "; cerr << "]\n";}
#define errf() {cerr << "\n\n";}
#define sq(x) ((x)*(x))

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

//mt19937 rng(random_device());

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

// ::::::::::::::::::::::::::::::::::::;

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    set<int> have;
    set<pair<int, int>> cur;
    for (int i = 0; i < n; ++i) {
        have.insert(i);
        cur.insert({gcd(a[i], a[(i + 1) % n]), i});
    }

    int pos = 0;
    vector<int> ans;
    while (true) {
        if (cur.empty()) break;
        if (cur.begin()->first > 1) break;

        auto lw = cur.lower_bound({1, pos});
        if (lw == cur.end() || lw->first > 1) {
            pos = 0;
            continue;
        }

        if (cur.size() == 1) {
            ans.push_back(lw->second);
            break;
        }

        int ind = lw->second;
        auto nxpos = have.upper_bound(ind);
        int nxt = 0;
        if (nxpos == have.end())
            nxt = *have.begin();
        else
            nxt = *nxpos;

        int nxtnxt = 0;
        nxpos = have.upper_bound(nxt);
        if (nxpos == have.end())
            nxtnxt = *have.begin();
        else
            nxtnxt = *nxpos;

        cur.erase({1, ind});
        cur.erase({gcd(a[nxt], a[nxtnxt]), nxt});
        cur.insert({gcd(a[ind], a[nxtnxt]), ind});
        have.erase(nxt);
        ans.push_back(nxt);
        pos = ind + 1;
    }

    cout << ans.size();
    for (int x : ans)
        cout << ' ' << x + 1;
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();

    return 0;
}

