#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <cmath>
#include <time.h>
#include <random>
#include <chrono>
#include <cassert>
#include <limits>

using namespace std;

#define int long long 
#define pb push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define ld long double

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) out << k << " ";
	return out;
}

ostream& operator<< (ostream& out, const pii& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else 
	#define dbg(x) 
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 10;

int n;
int a[N];
int p[N], sz[N], ind[N];

int par(int v) {
	if (p[v] == v) return v;
	return p[v] = par(p[v]);
}

void join(int u, int v) {
	u = par(u), v = par(v);
	if (u != v) {
		int nwind = ind[u];
		if (sz[u] > sz[v]) {
			swap(u, v);
		}
		p[u] = v;
		sz[v] += sz[u];
		ind[v] = nwind;
	}
}

void nw() {
	for (int i = 0; i < n; i++) {
		p[i] = i;
		sz[i] = 1;
		ind[i] = i;
	}
}

int gcd(int a, int b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int goodl(int x) {
	if (x == -1) return x + n;
	return x;
}

int goodr(int x) {
	if (x == n) return 0;
	return x;
}

set<int> bad, have;

int fnxt(int ind) {
	auto it = have.upper_bound(ind);
	if (it == have.end()) it = have.begin();
	return *it;
}

int fprev(int ind) {
	auto it = have.lower_bound(ind);
	if (it == have.begin()) it = (--have.end());
	else --it;
	return *it;
}

void solve() {
	int n;
	cin >> n;
	nw();
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	bad.clear();
	have.clear();
	for (int i = 0; i < n; i++) {
		have.insert(i);
		int ind = i - 1;
		if (i == 0) ind = n - 1;
		if (gcd(a[i], a[ind]) == 1) {
			bad.insert(i);
		}
	}
	int cur = 0;
	vector<int> ans;
	while (!bad.empty() && have.size() > 1) {
		// dbg(cur);
		auto it = bad.upper_bound(cur);
		if (it == bad.end()) it = bad.begin();
		int pos = *it;
		cur = pos;
		ans.pb(pos + 1);
		int prev = fprev(pos);
		int nxt = fnxt(pos);
		// cout << prev << " " << pos << " " << nxt << "\n";
		have.erase(pos);
		bad.erase(pos);
		bad.erase(nxt);
		cur = nxt;
		if (gcd(a[prev], a[nxt]) == 1) {
			bad.insert(nxt);
		}
	}
	if (have.size() == 1 && a[*have.begin()] == 1) ans.pb(*have.begin() + 1);
	cout << ans.size() << " " << ans << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	have.insert(1);
	have.insert(2);
    int q = 1;
    cin >> q;
    while (q--) {
    	solve();
    }
}
/*

*/