#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int gcd(int a, int b) {
  while (b != 0) {
    a %= b;
    swap(a, b);
  }
  return a;
}

int main(){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  while (t--) {
    int n;
    cin >> n;
    vector<int> A(n);
    for (int i = 0; i < n; ++i)
      cin >> A[i];
    vector<int> nxt(n);
    vector<int> pre(n);
    for (int i = 0; i + 1 < n; ++i)
      nxt[i] = i + 1;
    nxt[n - 1] = 0;
    for (int i = 1; i < n; ++i)
      pre[i] = i - 1;
    pre[0] = n - 1;
    deque<pair<int, int>> Q;
    for (int i = 0; i < n; ++i) {
      if (gcd(A[i], A[nxt[i]]) == 1) {
        Q.emplace_back(i, nxt[i]);
      }
    }
    vector<int> ans;
    vector<bool> used(n, false);
    while (!Q.empty()) {
      int a = Q.front().first;
      int b = Q.front().second;
      Q.pop_front();
      if (used[b] || used[a] || nxt[a] != b)
        continue;
      used[b] = true;
      ans.emplace_back(b);
      int c = nxt[b];
      nxt[a] = c;
      pre[c] = a;
      if (gcd(A[a], A[c]) == 1)
        Q.emplace_back(a, c);
    }
    cout << ans.size() << ' ';
    for (int x : ans)
      cout << x + 1 << ' ';
    cout << '\n';
  }
  return 0;
}
