﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <queue>
#include <bitset>
#include <assert.h>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	return bin_pow(a, n - 1) * a;
}
struct vertex {
	int x;
	vertex() = default;
	vertex(int a) {
		x = a;
	}
	bool operator<(vertex b) {
		return x < b.x;
	}
};
vector<vertex>tree;
vertex trash;
vector<int>out;

vector<int>arr;

struct DSU {
	vector<pair<int,int>>p;
	int n;
	queue<pair<int, int>>dels;
	DSU(int a) {
		n = a;
		p.resize(n);
		
		for (int i = 1; i < n; i++)
			p[i] = { i - 1, i + 1 };
		p[0] = { n - 1, 1 };
		p[n - 1] = { n - 2, 0 };
		if (n == 1) {
			p[0] = { 0, 0 };
		}

		for (int i = 1; i < n; i++) {
			if (gcd(arr[i], arr[p[i].first]) == 1) {
				dels.push({ i, p[i].first });
			}
		}
		if (gcd(arr[n - 1], arr[0]) == 1)
			dels.push({ 0, n - 1 });
	}
	void do_del() {
		pair<int,int> pr = dels.front();
		dels.pop();
		if (p[pr.first].first == -1 || p[pr.second].first == -1)
			return;
		int ind = pr.first;
		out.push_back(ind);
		int f = p[ind].second, b = p[ind].first;
		p[f].first = b;
		p[b].second = f;
		if (gcd(arr[f], arr[b]) == 1)
			dels.push({ f, b });
		p[ind] = { -1, -1 };
	}
};

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		arr.resize(n);
		for (auto& i : arr)
			cin >> i;
		DSU d(n);
		while (d.dels.size() != 0) {
			d.do_del();
		}
		cout << out.size() << ' ';
		for (auto i : out)
			cout << i + 1 << ' ';
		cout << '\n';
		out.clear();
	}
	return 0;
}