#include <iostream>
#include <algorithm>
#include <cmath>
#include <array>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <functional>
#include <ctime>
#include <random>
#include <cstdio>


using namespace std;

#define int long long		//!!!

const int INF = 4e18;
const int MOD = 1e9 + 7;
const int N = 5e5 + 10;
const int M = 5e3 + 10;
const int T = 1e6 + 10;

struct DSU {
	struct Node {
		int pr;
		int sz;
		int e;
		Node(int pr) : pr(pr), sz(1), e(pr) {}
		Node() {}
	};

	int n;
	vector <Node> p;

	DSU(int n) : n(n) {
		p.resize(n);
		for (int i = 0; i < n; i++)
			p[i] = { i };
	}

	int root(int v) {
		return p[v].pr == v ? v : p[v].pr = root(p[v].pr);
	}

	void unite(int u, int v) {
		u = root(u);
		v = root(v);

		int tmp = p[v].e;
		if (p[u].sz > p[v].sz)
			swap(u, v);
		p[v].sz += p[u].sz;
		p[v].e = tmp;
		p[u].pr = v;
	}

	int size(int x) {
		return p[root(x)].sz;
	}

	int end(int x) {
		return p[root(x)].e;
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	srand(time(NULL));

	int ttt = 1;
	cin >> ttt;
	while (ttt--) {
		int n;
		cin >> n;
		vector <int> a(n);
		for (int& i : a)
			cin >> i;
		DSU d(n);

		set <int> s;
		for (int i = 0; i < n; i++) {
			int nx = (i + 1) % n;
			if (gcd(a[i], a[nx]) == 1)
				s.insert(i);
		}
		vector <int> ans;
		vector <bool> used(n);

		while (!s.empty()) {
			int v = *s.begin();
			int i = v % n;

			if (used[i]) {
				s.erase(s.begin());
				continue;
			}

			int j = (d.end(i) + 1) % n;
			ans.emplace_back(j);
			d.unite(i, j);
			s.erase(s.begin());
			used[j] = true;

			int nw = (d.end(i) + 1) % n;
			if (gcd(a[i], a[nw]) == 1)
				s.insert(v + n);
		}

		cout << ans.size() << ' ';
		for (int i : ans)
			cout << i + 1 << ' ';
		cout << '\n';
		cout << '\n';
	}
	return 0;
}
