/*
  _           _                 _                 ___  _
 | |         | |               | |               / _ \(_)
 | |__   __ _| | __ _ _ __   __| | __ _         | | | |_  __ _
 | '_ \ / _` | |/ _` | '_ \ / _` |/ _` |        | | | | |/ _` |
 | |_) | (_| | | (_| | | | | (_| | (_| |        | |_| | | (_| |
 |_.__/ \__,_|_|\__,_|_| |_|\__,_|\__,_|         \___/|_|\__, |
                                         ______             | |
                                        |______|            |_|
  __ _  __ _   _ __ ___   __ ___   _________  ___
 / _` |/ _` | | '_ ` _ \ / _` \ \ / /_  / _ \/ __|
| (_| | (_| | | | | | | | (_| |\ V / / /  __/\__ \
 \__, |\__, | |_| |_| |_|\__,_| \_/ /___\___||___/
    | |   | |
    |_|   |_|
govetz, goni sotku!!
 * */
#include <bits/stdc++.h>

using namespace std;
#define int long long

#ifdef DEBUG
inline string to_string(string s) {
    return s;
}
#define dbg(format, ...) fprintf(stderr, to_string(format).c_str() __VA_OPT__(,) __VA_ARGS__); cerr << endl
#else
#define dbg(...) 42
#define endl '\n'
#endif

struct Node{
    Node *l, *r;
    int sz, y;
    pair<int, int> val, mn;
    Node(pair<int, int> x){
        l = r = nullptr;
        y = (rand() << 16) + rand();
        sz = 1;
        val = mn = x;
    }
};

Node *pull(Node *t){
    t->mn = t->val;
    t->sz = 1;
    if(t->l) t->mn = min(t->mn, t->l->mn);
    if(t->l) t->sz += t->l->sz;
    if(t->r) t->mn = min(t->mn, t->r->mn);
    if(t->r) t->sz += t->r->sz;
    return t;
}

Node* merge(Node *l, Node *r){
    if(!l) return pull(r);
    if(!r) return pull(l);
    if(l->y > r->y){
        l->r = merge(l->r, r);
        return pull(l);
    } else {
        r->l = merge(l, r->l);
        return pull(r);
    }
}

pair<Node*, Node*> split(Node *t, int x){
    if(!t) return {t, t};
    int ls = 0;
    if(t->l) ls += t->l->sz;
    if(x <= ls){
        auto to = split(t->l, x);
        t->l = to.second;
        return {to.first, pull(t)};
    } else {
        auto to = split(t->r, x - ls  - 1);
        t->r = to.first;
        return {pull(t), to.second};
    }
}

void print(Node *t){
    if(!t) return ;
    print(t->l);
    cout << t->val.first << ' ';
    print(t->r);
}

pair<int, int> get(Node* t, int l){
//    print(t);
//    cout << ": " << l << endl;
    auto to = split(t, l);
    auto ans = to.second->mn;
    t = merge(to.first, to.second);
    return ans;
}

int get(int v, vector<bool> &rem, vector<int> &lb){
    if(!rem[lb[v]]) return lb[v];
    lb[v] = get(lb[v], rem, lb);
    return lb[v];
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t --> 0){
        int n;
        cin >> n;
        if(n == 1){
            int x;
            cin >> x;
            if(x == 1) cout << "1 1\n";
            else cout << "0\n";
            continue;
        }
        vector<int> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i];
        }
//        if(n <= 3){
//            //stupid
//            int cycwo = 0;
//            vector<bool> rem(n, 0);
//            vector<int> rm;
//            int i = 0;
//            int lst = -1;
//            while(true){
//                if(rm.size() >= n) break;
//                if(rem[i]) {
//                    i++;
//                    i %= n;
//                    continue;
//                }
//                cycwo++;
//                if(cycwo >= 15 * n) break;
//                if(lst != -1 && __gcd(v[i], lst) == 1){
//                    rem[i] = 1;
//                    rm.push_back(i);
//                    lst = -1;
//                    cycwo = 0;
//                    continue;
//                }
//                lst = v[i];
//                i++;
//                i %= n;
//            }
//            cout << rm.size() << ' ';
//            for(auto to: rm) cout << to + 1 << ' ';
//            cout << endl;
////            cout << n << endl;
//            continue;
//        }
        Node *tree = nullptr;
        for(int i = 0; i < n; i++){
            Node *ins = new Node({__gcd(v[i], v[(i - 1 + n) % n]), i});
            tree = merge(tree, ins);
        }
        get(tree, 1);
        vector<int> lu(n), lb(n);
        iota(lu.begin() + 1, lu.end(), 0);
        iota(lb.begin(), lb.end(), 1);
        lb[n - 1] = 0;
        lu[0] = n - 1;
        vector<bool> rem(n, false);
        int cx = 1;
        vector<int> rm;
        while(true){
            if(tree->mn.first > 1) break;
            auto to = get(tree, cx);
//            cout << to.first << ' ' << to.second << "?" << endl;
            if(to.first > 1){
                cx = 0;
                continue;
            }
            rem[to.second] = 1;
            rm.push_back(to.second);
            if(rm.size() == n) break;
            int tsn = get(to.second, rem, lb);
            int tss = get(to.second, rem, lu);
            auto too = split(tree, to.second);
            auto tooo = split(too.second, 1);
            tooo.first = new Node({3e9, 3e9});
            too.second = merge(tooo.first, tooo.second);
            tree = merge(too.first, too.second);
//            print(tree);
            too = split(tree, tsn);
            tooo = split(too.second, 1);
//            cout << ":";
//            cout << tsn << "->" << lu[tsn] << endl;

            tooo.first = new Node({__gcd(v[get(tsn, rem, lu)], v[tsn]), tsn});
            too.second = merge(tooo.first, tooo.second);
            tree = merge(too.first, too.second);
//            print(tree);
//            cout << endl;
            cx = get(to.second, rem, lb);
            cx = get(cx, rem, lb);
//            cout << "after: ";
//            for(int i = 0; i < n; i++){
//                if(!rem[i]) cout << v[i] << ' ';
//            }
//            cout << endl;
//            for(int i = 0; i < n; i++){
//                cout << lu[i] << ' ';
//            }
//            cout << endl;
//            for(int i = 0; i < n; i++){
//                cout << lb[i] << ' ';
//            }
//            cout << endl;
        }
        cout << rm.size() << ' ';
        for(auto to: rm) cout << to + 1 << ' ';
        cout << endl;
    }
}
