#include <bits/stdc++.h>

//#define int long long

using namespace std;

const int MAXN = 1e5 + 10;
const int INF = 1e9 + 100;

int tree[MAXN * 4];
vector<int> inp;
vector<int> arr, rr, ll;

void build(int v, int l, int r) {
  if (l + 1 == r) {
    tree[v] = arr[l];
    return;
  }
  int m = (l + r) / 2;
  build(2 * v + 1, l, m);
  build(2 * v + 2, m, r);
  tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

void reset(int n) {
  fill(tree, tree + n * 4 + 10, INF);
}

int get(int v, int l, int r, int ql, int qr) {
  if (qr <= l || r <= ql)
    return INF;
  if (ql <= l && r <= qr)
    return tree[v];
  int m = (l + r) / 2;
  int a = get(2 * v + 1, l, m, ql, qr);
  int b = get(2 * v + 2, m, r, ql, qr);
  return min(a, b);
}

void upd(int v, int l, int r, int qi, int qx) {
  if (qi < l || r <= qi)
    return;
  if (l + 1 == r) {
    tree[v] = qx;
    return;
  }
  int m = (l + r) / 2;
  upd(2 * v + 1, l, m, qi, qx);
  upd(2 * v + 2, m, r, qi, qx);
  tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);;
}

int n;
int getmin(int i, int len) {
  if (i + len <= n) {
    return get(0, 0, n, i, i + len);
  }
  int a = get(0, 0, n, i, n);
  int b = get(0, 0, n, 0, len - (n - i));
  return min(a, b);
}

int getind(int i) {
  i = (i + 1) % n;
  int l = 0, r = n + 1;
  while (r - l > 1) {
    int m = (l + r) / 2;
    int g = getmin(i, m);
    if (g == 1)
      r = m;
    else
      l = m;
  }
  int j = (i + r - 1 + n) % n;
  if (r == n + 1)
    return -1;
  return j;
}

void solve() {
  cin >> n;
  inp.resize(n);
  for (int &el : inp)
    cin >> el;
  arr.resize(n);
  rr.resize(n);
  ll.resize(n);
  for (int i = 0; i < n; ++i) {
    int j = (i - 1 + n) % n;
    arr[i] = gcd(inp[i], inp[j]);
    ll[i] = j;
    rr[j] = i;
  }
  reset(n);
  build(0, 0, n);
  int i = 0;
  vector<int> ans;
  while (ans.size() < n) {
    int j = getind(i);
    if (j == -1)
      break;
//    j = (j + 1) % n;
    ans.push_back(j + 1);
    int l = ll[j];
    int r = rr[j];
    rr[l] = r;
    ll[r] = l;
    upd(0, 0, n, j, INF);
    i = r;
    int x = gcd(inp[i], inp[l]);
    upd(0, 0, n, i, x);
  }
  cout << ans.size() << ' ';
  for (int el : ans)
    cout << el << ' ';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t = 1;
  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }
}