#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define size(x) x.size()
#define all(x) x.begin(), x.end()

ll gcd(ll a, ll b)
{
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

vector<int> tree;

void build_tree(int i, int l, int r)
{
	tree[i] = l;
	if (l + 1 == r)
		return;
	int k = (l + r) / 2;
	build_tree(2 * i + 1, l, k);
	build_tree(2 * i + 2, k, r);
}

int get_next(int i, int l, int r, int q)
{
	if (r <= q)
		return 1000000;
	if (q <= l)
		return tree[i];
	int k = (l + r) / 2;
	int L = get_next(2 * i + 1, l, k, q);
	int R = get_next(2 * i + 2, k, r, q);
	int ans = min(L, R);
	return ans;
}

int del(int i, int l, int r, int q)
{
	if (r <= q || q < l)
		return tree[i];
	if (l + 1 == r)
	{
		tree[i] = 1000000;
		return tree[i];
	}
	int k = (l + r) / 2;
	int L = del(2 * i + 1, l, k, q);
	int R = del(2 * i + 2, k, r, q);
	int ans = min(L, R);
	tree[i] = ans;
	return ans;
}

void solve()
{
	 int n; cin >> n;
	 vector<ll> a(n);
	 tree.resize(4 * n, 0);
	 build_tree(0, 0, n);
	 for (int i = 0; i < n; ++i)
		 cin >> a[i];
	 vector<pii> td;
	 set<int> ts;
	 for (int i = 0; i < n; ++i)
	 {
		 int nxt = (i + 1) % n;
		 if (ts.count(i) == 0 && gcd(a[i], a[nxt]) == 1)
			 td.push_back(make_pair(i, nxt)), ts.insert(nxt);
	 }
	 vector<int> ans;
	 while(size(td))
	 {
		 vector<int> tch;
		 for (int i = 0; i < size(td); ++i)
		 {
			 pii nw = td[i];
			 del(0, 0, n, nw.second);
			 ans.push_back(nw.second);
			 ts.insert(nw.second);
			 tch.push_back(nw.first);
		 }
		 td.clear();
		 for (int i = 0; i < size(tch); ++i)
		 {
			 int elem = tch[i];
			 if (ts.count(elem) == 0)
			 {
				 int nxt = (elem + 1) % n;
				 nxt = get_next(0, 0, n, nxt);
				 if (nxt > n)
					 nxt = get_next(0, 0, n, 0);
				 if (nxt < n && gcd(a[elem], a[nxt]) == 1)
				 {
					 ts.insert(nxt);
					 td.push_back(make_pair(elem, nxt));
				 }
			 }
		 }
		 tch.clear();
	 }
	 cout << size(ans);
	 for (int i = 0; i < size(ans); ++i)
		 cout << ' ' << (ans[i] + 1);
	 cout << '\n';
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while(t--)
		solve();
	//cin.get(); cin.get(); cin.get();
	return 0;
}