#include <bits/stdc++.h>
#define x first
#define y second
#define int long long
#define ld long double

using namespace std;

mt19937_64 rnd(42);
ld eps = 1e-7;
ld pi = acos(-1);
struct node;
typedef node* pnode;
struct node{
    int val;
    int sz;
    pnode l;
    pnode r;
    int prior;
    int sum;
    node(){}
    node(int x){
        val = x;
        sum = x;
        sz = 1;
        prior = rnd();
        l = 0;
        r = 0;
    }
};
pnode root;
struct dd{
    dd(){}
    int getsz(pnode t){
        if(!t)
            return 0;
        return t->sz;
    }
    int getsum(pnode t){
        if(!t)
            return 0;
        return t->sum;
    }
    void upd(pnode t){
        if(!t)
            return;
        t->sz = getsz(t->l)+getsz(t->r)+1;
        t->sum = getsum(t->l)+getsum(t->r)+t->val;
    }
    pnode merge(pnode t, pnode v){
        if(!t)
            return v;
        if(!v)
            return t;
        if(t->prior>v->prior){
            pnode p = merge(t->r, v);
            t->r = p;
            upd(t);
            return t;
        }
        pnode p = merge(t, v->l);
        v->l = p;
        upd(v);
        return v;
    }
    pair<pnode, pnode> split(pnode t, int x){
        if(!t)
            return {0, 0};
        if(getsz(t->l)>x){
            auto p = split(t->l, x);
            t->l = p.y;
            upd(t);
            return {p.x, t};
        }
        auto p = split(t->r, x-getsz(t->l)-1);
        t->r = p.x;
        upd(t);
        return {t, p.y};
    }

    int getsum(pnode t, int l, int r){
        auto p = split(t, l-1);
        auto p1 = split(p.y, r-l-1);
        int ans = p1.x->sum;
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
        return ans;
    }

    int getkth(pnode t, int k){
        auto p = split(t, k-1);
        auto p1 = split(p.y, 0);
        int ans = p1.x->val;
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
        return ans;
    }

    void printtree(pnode t){
        if(!t)
            return;
        printtree(t->l);
        cout << t->val << " ";
        printtree(t->r);
    }
};

struct dd1{
    dd1(){}
    int getsz(pnode t){
        if(!t)
            return 0;
        return t->sz;
    }
    int getsum(pnode t){
        if(!t)
            return 0;
        return t->sum;
    }
    void upd(pnode t){
        if(!t)
            return;
        t->sz = getsz(t->l)+getsz(t->r)+1;
        t->sum = getsum(t->l)+getsum(t->r)+t->val;
    }
    pnode merge(pnode t, pnode v){
        if(!t)
            return v;
        if(!v)
            return t;
        if(t->prior>v->prior){
            pnode p = merge(t->r, v);
            t->r = p;
            upd(t);
            return t;
        }
        pnode p = merge(t, v->l);
        v->l = p;
        upd(v);
        return v;
    }
    pair<pnode, pnode> split(pnode t, int k){
        if(!t)
            return {0, 0};
        if(t->val>k){
            auto p = split(t->l, k);
            t->l = p.y;
            upd(t);
            return {p.x, t};
        }
        auto p = split(t->r, k);
        t->r = p.x;
        upd(t);
        return {t, p.y};
    }

    bool add(pnode t, int k){
        auto p = split(t, k-1);
        auto p1 = split(p.y, k);
        if(getsz(p1.x)>0){
            p.y = merge(p1.x, p1.y);
            t = merge(p.x, p.y);
            return 0;
        }
        p1.x = new node(k);
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
        return 1;
    }

    void del(pnode t, int k){
        auto p = split(t, k-1);
        auto p1 = split(p.y, k);
        p1.x = 0;
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
    }

    int getkth(pnode t, int k){
        if(!t)
            return INT_MIN;
        if(getsz(t->l)==k)
            return t->val;
        else if(getsz(t->l)<k)
            return getkth(t->l, k);
        else return getkth(t->r, k-getsz(t->l)-1);
    }
    void printtree(pnode t){
        if(!t)
            return;
        printtree(t->l);
        cout << t->val << " ";
        printtree(t->r);
    }
};

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int qq = 1;
    cin >> qq;
    for(int qqq = 0; qqq<qq; qqq++){
        int n;
        cin >> n;
        int a[n];
        bool lv[n];
        set<int> all;
        vector<int> ans;
        for(int i = 0; i<n; i++){
            cin >> a[i];
            lv[i] = 1;
            all.insert(i);
        }
        set<pair<int, int>> gcd;
        for(int i = 0; i<n-1; i++){
            if(__gcd(a[i], a[i+1])==1)
                gcd.insert({i, i+1});
        }
        if(__gcd(a[n-1], a[0])==1)
            gcd.insert({n-1, 0});
        int last = -1;
        while(gcd.size()>0){
            auto it = gcd.upper_bound({last, INT_MAX});
            if(it==gcd.end()){
                last = -1;
                continue;
            }

            int i = (*it).x;
            int j = (*it).y;
            gcd.erase(it);
            if(!lv[i]){
                continue;
            }
            ans.push_back(j+1);
            lv[j] = 0;
            all.erase(j);
            last = j;
            auto it1 = all.upper_bound(i);
            if(all.size()==0)
                break;
            if(it1==all.end()){
                it1 = all.begin();
            }
            j = *it1;
            if(i==j){
                if(a[i]==1){
                    ans.push_back(i+1);
                }
                break;
            }
            if(__gcd(a[i], a[j])==1){
                gcd.insert({i, j});
            }

        }
        cout << ans.size() << " ";
        for(auto z:ans)
            cout << z << " ";
        cout << "\n";
    }
    return 0;
}
