#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <climits>
#include <cassert>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>
#include <numeric>

#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	vector<int> next(n);
	set<pair<int, int>> st;

	for (int i = 0; i < n; ++i) {
		int j = (i + 1) % n;
		if (gcd(a[i], a[j]) == 1) {
			st.insert({ i, j });
		}

		next[i] = j;
	}

	vector<int> ans;

	int cur = 0;

	while (!st.empty()) {
		auto it = st.lower_bound({ cur, -1 });
		if (it == st.end()) {
			cur = 0;
		}
		else {
			auto [i, j] = *it;
			st.erase(it);
			ans.push_back(j);

			if (i != j) {
				int k = next[j];
				st.erase({ j, k });

				next[i] = k;
				if (gcd(a[i], a[k]) == 1) {
					st.insert({ i, k });
				}
			}
			cur = j + 1;
		}
	}

	cout << sz(ans) << " ";
	for (int i : ans) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}


int main() {
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}