#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <time.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define pb push_back
#define forin for(int i = 0; i < n; ++i)

const bool is_debug = true;
#define debug(x) if(is_debug) cout << x << '\n'

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class T>
ostream& operator << (ostream &a, vector<T> x) {
    for(auto element: x) {
        a << element << ' ';
    }
    return a;
}

template<class T>
istream& operator >> (istream &a, vector<T> x) {
    for(auto &element: x) {
        a >> x;
    }
    return a;
}

mt19937 rnd(time(0));


vector<int> t;
vector<int> a;

void update(int v) {
    if(t[2*v + 1] != -1) {
        t[v] = t[2*v + 1];
    }else{
        t[v] = t[2*v + 2];
    }
}

void build(int v, int l, int r) {
    if(l + 1 == r) {
        if(a[l] == 1) {
            t[v] = l;
        }else{
            t[v] = -1;
        }
        return;
    }
    int m = (l + r) / 2;
    build(2*v + 1, l, m);
    build(2*v + 2, m, r);
    update(v);
}

void change(int v, int l, int r, int pos, int val) {
    if(l + 1 == r) {
        a[l] = val;
        if(a[l] == 1) {
            t[v] = l;
        }else{
            t[v] = -1;
        }
        return;
    }
    int m = (l + r) / 2;
    if(pos < m) {
        change(2*v + 1, l, m, pos, val);
    }else{
        change(2*v + 2, m, r, pos, val);
    }
    update(v);
}

int get(int v, int l, int r, int askl, int askr) {
    if(askl <= l && r <= askr) return t[v];
    if(r <= askl || askr <= l) return -1;
    int m = (l + r) / 2;
    int ansl = get(2*v + 1, l, m, askl, askr);
    if(ansl != -1) return ansl;
    return get(2*v + 2, m, r, askl, askr);
}

int gcd(int a, int b) {
    if(a < b) swap(a, b);
    if(b == 0) return a;
    return gcd(b, a % b);
}

signed main() {
    int t_;
    cin >> t_;
    for(int q = 0; q < t_; ++q) {
        int n;
        cin >> n;
        vector<int> x(n);
        for(int i = 0; i < n; ++i) cin >> x[i];

        vector<int> prev(n), next(n);
        a.assign(n, 0);
        for(int i = 0; i < n; ++i) {
            prev[i] = (n + i - 1) % n;
            next[i] = (i + 1) % n;
            a[i] = gcd(x[i], x[prev[i]]);
        }
        t.resize(4*n, -1);
        build(0, 0, n);

        vector<int> res;

        int cur = 0;
        vector<int> used(n, false);
        while(n - res.size() >= 2) {
            int ans = get(0, 0, n, cur + 1, n);
            if(ans == -1) ans = get(0, 0, n, 0, cur + 1);
            if(ans == -1) break;
            used[ans] = true;
            res.push_back(ans + 1);
            change(0, 0, n, ans, 0);
            prev[next[ans]] = prev[ans];
            next[prev[ans]] = next[ans];
            change(0, 0, n, next[ans], gcd(x[next[ans]], x[prev[ans]]));
            cur = next[ans];
        }

        vector<int> other;
        for(int i = 0; i < n; ++i) {
            if(!used[i]) other.push_back(i);
        }

        if(other.size() == 1 && x[other[0]] == 1) res.push_back(other[0] + 1);

        cout << res.size() << ' ' << res << '\n';
    }
    return 0;
}
