#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
#define int long long

struct SegTree {
    int n;
    vi tree;
    SegTree(int n) : n(n), tree(4 * n, n) {}
    void set(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            if (val) tree[v] = l;
            else tree[v] = n;
            return;
        }
        int mid = (l + r) / 2;
        if (pos < mid)
            set(2 * v, l, mid, pos, val);
        else
            set(2 * v + 1, mid, r, pos, val);
        tree[v] = min(tree[2 * v], tree[2 * v + 1]);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (ql >= qr)
            return n;
        if (qr <= l || r <= ql)
            return n;
        if (ql <= l && r <= qr)
            return tree[v];
        int mid = (l + r) / 2;
        return min(get(2 * v, l, mid, ql, qr),
        get(2 * v + 1, mid, r, ql, qr));
    }
};

int gcd(int a, int b) {
    while (b) {
        int tmp = b;
        b = a % b;
        a = tmp;
    }
    return a;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    for (int qt = 0; qt < q; ++qt) {
        int n;
        cin >> n;
        vi arr(n), prev(n), next(n);
        for (int i = 0; i < n; ++i)
            cin >> arr[i];
        for (int i = 0; i < n; ++i) {
            int j = (i + n - 1) % n;
            prev[i] = j;
            next[j] = i;
        }
        SegTree stop(n);
        for (int i = 0; i < n; ++i)
            if (gcd(arr[prev[i]], arr[i]) == 1)
                stop.set(1, 0, n, i, 1);
        int may_start = 1, cnt_alive = n;
        vi order;
        while (cnt_alive) {
            int pos = stop.get(1, 0, n, may_start, n);
            if (pos == n)
                pos = stop.get(1, 0, n, 0, n);
            if (pos == n)
                break;
            prev[next[pos]] = prev[pos];
            next[prev[pos]] = next[pos];
            order.push_back(pos);
            --cnt_alive;
            may_start = next[next[pos]];
            stop.set(1, 0, n, pos, 0);
            if (gcd(arr[prev[pos]], arr[next[pos]]) == 1)
                stop.set(1, 0, n, next[pos], 1);
            else
                stop.set(1, 0, n, next[pos], 0);
        }
        cout << order.size() << ' ';
        for (int e : order)
            cout << e + 1 << ' ';
        cout << '\n';
    }
}
