// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define int long long

#ifdef LOCAL
	const int N = (1 << 10);
#else
	const int N = (1 << 20);
#endif

struct Seg_tree {
	int t[2 * N + 228];
	int mod[2 * N + 228];
	Seg_tree(vector<int> a) {
		fill(t, t + 2 * N + 228, 0);
		fill(mod, mod + 2 * N + 228, 0);
		int n = a.size();
		for (int i = 0; i < n; ++i) {
			t[i + N] = a[i];
		}
		for (int i = N - 1; i > 0; --i) {
			t[i] = max(t[2 * i], t[2 * i + 1]);
		}
	}

	void push(int i) {
		if (i < N) {
			mod[2 * i] += mod[i];
			mod[2 * i + 1] += mod[i];
		}
		t[i] += mod[i];
		mod[i] = 0;
	}

	int get(int v, int tl, int tr, int l, int r) {
		push(v);
		if (l <= tl && tr <= r) return t[v];
		if (tl >= r || tr <= l) return 0;
		int m = (tl + tr) / 2;
		return max(get(2 * v, tl, m, l, r), get(2 * v + 1, m, tr, l, r));
	}

	void update(int v, int tl, int tr, int l, int r, int x) {
		if (l <= tl && tr <= r) {
			mod[v] += x;
			push(v);
			return;
		}
		push(v);
		if (tl >= r || tr <= l) return;
		int m = (tl + tr) / 2;
		update(2 * v, tl, m, l, r, x);
		update(2 * v + 1, m, tr, l, r, x);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
};


const int MAXN = 1e5;
int a[MAXN];

signed main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
		cout.tie(nullptr);
		cout << fixed << setprecision(15);
	#endif
	int T;
	cin >> T;
	while (T --> 0) {
		int n;
		cin >> n;
		for (int i = 0; i < n; ++i) cin >> a[i];
		vector<int> ans;
		vector<bool> used(n);
		set<int> left;
		vector<int> right(n);
		for (int i = 0; i < n; ++i) {
			right[i] = (i + 1) % n;
		}
		{
			int last = -1;
			for (int i = 0; i <= n; ++i) {
				if (used[i % n]) continue;
				if (last == -1) {
					last = i;
					continue;
				}
				if (__gcd(a[last], a[i % n]) == 1) {
					ans.emplace_back(i % n);
					used[i % n] = true;
					left.emplace(last);
					right[last] = right[i % n];
					last = -1;
				} else {
					last = i;
				}
			}
		}
		// cout << "! " << ans.size() << " : ";
		// for (auto x : ans) cout << x + 1 << ' ';
		// cout << endl;

		// for (int i = 0; i < n; ++i) cout << right[i] + 1 << ' ';
		// cout << endl;


		while (!left.empty()) {
			vector<int> to_erase;
			for (auto x : left) {
				if (used[x]) {
					to_erase.emplace_back(x);
					continue;
				}
				if (used[right[x]]) {
					to_erase.emplace_back(x);
					continue;
				}

				if (__gcd(a[x], a[right[x]]) == 1) {
					ans.emplace_back(right[x]);
					used[right[x]] = true;
					right[x] = right[right[x]];
				} else {
					to_erase.emplace_back(x);
				}
			}
			for (auto x : to_erase) left.erase(x);
		}
		cout << ans.size() << ' ';
		for (auto x : ans) cout << x + 1 << ' ';
		cout << '\n';
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s    ";
	#endif
	return 0;
}