#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 _mt(seed);

int _gcd(int a, int b) {
    while (b) {
        int tmp = b;
        b = a % b;
        a = tmp;
    }
    return a;
}

struct node {
    int l, r;
    int left, right;
    node(){}
};

struct tree {
    vector <node> t;
    tree(int n) {
        t.resize(4 * n);
        build(0, 0, n);
    }
    void pull(int v) {
        if (t[v + v + 1].left < 0)
            t[v].left = t[v + v + 2].left;
        else
            t[v].left = t[v + v + 1].left;
        if (t[v + v + 2].right < 0)
            t[v].right = t[v + v + 1].right;
        else
            t[v].right = t[v + v + 2].right;
    }
    void build(int v, int l, int r) {
        t[v].l = l; t[v].r = r;
        t[v].left = l; t[v].right = r - 1;
        if (r - l == 1)
            return;
        int m = (l + r) >> 1;
        build(v + v + 1, l, m);
        build(v + v + 2, m, r);
    }
    void upd(int v, int i) {
        if (t[v].r - t[v].l == 1) {
            t[v].left = -1;
            t[v].right = -1;
            return;
        }
        int m = (t[v].l + t[v].r) >> 1;
        if (i < m)
            upd(v + v + 1, i);
        else
            upd(v + v + 2, i);
        pull(v);
    }
    int _left(int v, int i) {
        if (t[v].r <= i)
            return t[v].right;
        if (t[v].l >= i)
            return -1;
        int x = _left(v + v + 1, i);
        int y = _left(v + v + 2, i);
        if (y < 0)
            return x;
        return y;
    }
    int _right(int v, int i) {
        if (t[v].l > i)
            return t[v].left;
        if (t[v].r - 1 <= i)
            return -1;
        int x = _right(v + v + 1, i);
        int y = _right(v + v + 2, i);
        if (x < 0)
            return y;
        return x;
    }
};

int dist(int i, int j, int n) {
    if (j < i) return i - j;
    return i - j + n;
}

int32_t main()
{
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    #endif
    int q; cin >> q;
    while (q--) {
        int n; cin >> n;
        vector <int> a(n);
        for (int i = 0; i < n; i++)
            cin >> a[i];
        tree t(n);
        vector <int> deleted, ans;
        for (int i = 1; i <= n; i++) {
            if (_gcd(a[i % n], a[i - 1]) == 1) {
                t.upd(0, i % n);
                deleted.push_back(i % n);
                ans.push_back(i % n);
                i++;
            }
        }
        vector <int> cur;
        while (!deleted.empty() && ans.size() < n - 1) {
            for (int j = 0; j < deleted.size(); j++) {
                int sz = deleted.size();
                int i = deleted[j], ii = deleted[(j - 1 + sz) % sz];
                int l = t._left(0, i), r = t._right(0, i);
                if (l < 0)
                    l = t._left(0, n);
                if (r < 0)
                    r = t._right(0, -1);
                if (dist(i, l, n) > dist(i, ii, n)) continue;
                if (_gcd(a[l], a[r]) == 1) {
                    t.upd(0, r);
                    cur.push_back(r);
                    ans.push_back(r);
                }
            }
            swap(cur, deleted);
            cur.clear();
        }
        if (ans.size() == n - 1) {
            int last = t._right(0, -1);
            if (a[last] == 1)
                ans.push_back(last);
        }
        cout << ans.size() << "   ";
        for (auto &el : ans)
            cout << el + 1 << " ";
        cout << "\n";
    }
    return 0;
}
