#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>
#include <tuple>

//#define int long long
#define ll long long
#define ld long double
#define accuracy(x) fixed << setprecision(x)

const int INF = (int)1e9;
const long long LINF = (long long)1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1.0);

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void file_in(string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

ld my_difftime(clock_t start, clock_t end)
{
    return (ld)(end - start) / ((ld)CLOCKS_PER_SEC / 1000);
}

void sleep(ld milliseconds)
{
    clock_t start = clock();
    for (clock_t end = clock(); my_difftime(start, end) < milliseconds; end = clock()) {}
}

struct Node
{
    Node* left;
    Node* right;
    int id;
    int value;
    bool freeze;
    bool will_be_deleted;

    Node()
    {
        left = right = nullptr;
        id = value = -1;
        freeze = will_be_deleted = false;
    }
    Node(int id, int value) : id(id), value(value)
    {
        left = right = nullptr;
        freeze = will_be_deleted = false;
    }
};

void process(Node& node, int phase, vector<int>& deletions, vector< vector<Node*> >& phase_deletes)
{
    Node* cur_neighbour = node.right;
    for (int add_phase = 0; ; ++add_phase)
    {
        if (node.id == cur_neighbour->id)
        {
            return;
        }
        if (gcd(node.value, cur_neighbour->value) == 1)
        {
            if (add_phase == 0)
            {
                deletions.push_back(cur_neighbour->id);
                node.right = cur_neighbour->right;
                cur_neighbour->right->left = &node;
            }
            else
            {
                phase_deletes[phase + add_phase].push_back(cur_neighbour);
                cur_neighbour->will_be_deleted = true;
            }
        }
        else
        {
            return;
        }
        cur_neighbour = cur_neighbour->right;
    }

}


void process2(Node& node, deque<Node*>& q, vector<int>& deletions, vector<char>& is_deleted)
{
    if (is_deleted[node.id])
    {
        return;
    }
    if (gcd(node.value, node.right->value) == 1)
    {
        deletions.push_back(node.right->id);
        is_deleted[node.right->id] = 1;
        node.right = node.right->right;
        node.right->right->left = &node;
        q.push_back(&node);
    }
}

void solve()
{
    int n;
    cin >> n;
    vector<Node> nodes(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> nodes[i].value;
        nodes[i].id = i;
        if (i)
        {
            nodes[i].left = &nodes[i - 1];
        }
        else
        {
            nodes[i].left = &nodes[n - 1];
        }
        if (i != n - 1)
        {
            nodes[i].right = &nodes[i + 1];
        }
        else
        {
            nodes[i].right = &nodes[0];
        }
    }

    vector<int> ans;
    vector<char> is_deleted(n);
    Node* cur_node = &nodes[0];
    deque<Node*> q;
    for (int last_id = -1; last_id < cur_node->id;)
    {
        last_id = cur_node->id;
        process2(*cur_node, q, ans, is_deleted);
        cur_node = cur_node->right;
    }

    while (!q.empty())
    {
        cur_node = q.front();
        q.pop_front();
        process2(*cur_node, q, ans, is_deleted);
    }


    /*vector<int> ans;
    vector< vector<Node*> > phase_deletes(n);
    Node* cur_node = &nodes[0];
    for (int last_id = -1; last_id < cur_node->id;)
    {
        last_id = cur_node->id;
        process(*cur_node, 0, ans, phase_deletes);
        cur_node = cur_node->right;
    }


    for (int current_phase = 1; current_phase < n; ++current_phase)
    {
        for (Node* node : phase_deletes[current_phase])
        {
            ans.push_back(node->id);
            node->left->right = node->right;
            node->right->left = node->left;
            if (!node->left->will_be_deleted)
            {
                node->right->freeze = false;
                process(*node, current_phase, ans, phase_deletes);
            }
        }
    }*/

    cout << ans.size() << ' ';
    for (int i : ans)
    {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}


signed main()
{
#ifndef LOCAL
    fast_io();
#else
    clock_t start = clock();
#endif

    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve();
    }

#ifdef LOCAL
    cerr << "TIME: " << accuracy(2) << my_difftime(start, clock()) << '\n';
#endif

}