#include <bits/stdc++.h>

using namespace std;
#define int long long
const int INF = 1e16;
vector <pair <int, int>> tree;
vector <int> p;

inline void push(int v) {
    if (p[v] == -INF) return;
    p[2 * v] = p[v];
    p[2 * v + 1] = p[v];
    tree[2 * v].first = tree[2 * v].second + p[v];
    tree[2 * v + 1].first = tree[2 * v + 1].second + p[v];
    p[v] = -INF;
}

int get_max(int v, int l, int r, int A, int B) {
    if (l > B || A > r) return -INF;
    if (A <= l && r <= B) {
        return tree[v].first;
    }
    push(v);
    int m = (l + r) / 2;
    return max(get_max(2 * v, l, m, A, B), get_max(2 * v + 1, m + 1, r, A, B));
}

void update_seg(int v, int l, int r, int A, int B, int x) {
    if (l > B || A > r) return;
    if (A <= l && r <= B) {
        p[v] = x;
        tree[v].first = tree[v].second + x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update_seg(2 * v, l, m, A, B, x);
    update_seg(2 * v + 1, m + 1, r, A, B, x);
    tree[v].first = max(tree[2 * v].first, tree[2 * v + 1].first);
}

void update(int v, int l, int r, int i, int x) {
    if (l > i || i > r) return;
    if (l == r) {
        tree[v].second = x;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v, l, m, i, x);
    update(2 * v + 1, m + 1, r, i, x);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    int n;
    cin >> n;
    vector <int> h(n), b(n);
    for (int i = 0; i < n; ++i) cin >> h[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    int len = 1 << (int)ceil(log2(n));
    tree.resize(2 * len);
    p.resize(2 * len, -INF);
    vector <int> dp(n);
    vector <int> bl(n, 0);
    vector <int> st;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && h[i] < h[st.back()]) {
            bl[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    int cur_min = -1;
    for (int i = 0; i < n; ++i) {
        if (cur_min == -1) cur_min = i;
        else if (h[cur_min] > h[i]) cur_min = i;
        update_seg(1, 0, len - 1, bl[i], i - 1, b[i]);
        int tmp = get_max(1, 0, len - 1, 0, i - 1);
        update(1, 0, len - 1, i, max(tmp, b[cur_min]));
        dp[i] = max(tmp, b[cur_min]);
    }
    cout << dp.back();
}