#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>
#include <numeric>
#include <random>
/*
#pragma GCC optimise("Ofast,O2,O3")
*/
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int N = (1 << 19);


struct Segment_tree {
    vector<ll> tree;


    Segment_tree() {
        tree.assign(N * 2 + 42, -l_inf);
    }


    ll get(int i, int left, int right, int q_left, int q_right) {
        if (right <= q_left || q_right <= left) {
            return -l_inf;
        } else if (q_left <= left && right <= q_right) {
            return tree[i];
        }
        int middle = (left + right) >> 1;
        return max(get(i * 2    , left, middle, q_left, q_right),
                   get(i * 2 + 1, middle, right, q_left, q_right));
    }


    ll get(int left, int right) {
        return get(1, 0, N, left, right + 1);
    }


    void update(int i, ll val) {
        i += N;
        tree[i] = val;
        while (i != 1) {
            i >>= 1;
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
        }
    }
};


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n;
    cin >> n;
    vector<ll> H(n), B(n);
    for (int i = 0; i < n; ++i) {
        cin >> H[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> B[i];
    }
    //
    vector<int> stack;
    vector<int> left(n, -1);
    for (int i = n - 1; i >= 0; --i) {
        while (!stack.empty() && H[i] < H[stack.back()]) {
            left[stack.back()] = i;
            stack.pop_back();
        }
        stack.push_back(i);
    }
    //
    vector<ll> dp(n, -l_inf);
    dp[0] = B[0];
    Segment_tree T;
    T.update(0, dp[0]);
    for (int i = 1; i < n; ++i) {
        int l = left[i] == -1 ? 0 : left[i];
        dp[i] = T.get(l, i - 1) + B[i];
        if (left[i] != -1) {
            dp[i] = max(dp[i], dp[left[i]]);
        } else {
            dp[i] = max(dp[i], B[i]);
        }
        T.update(i, dp[i]);
    }
    cout << dp[n - 1] << "\n";
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}
