//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <stack>
#include <bitset>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#if DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    solve();
}

#define int long long

const int N = 3e5 + 100, INF = 1e18, MOD = 998244353, BASE = 228, MOD1 = 1e9 + 7, BASE1 = 131;// 998244353
const double EPS = 0.0000001;

struct segment_tree {
    int t[4 * N];

    segment_tree() {
        for (int i = 0; i < 4 * N; i++) {
            t[i] = -INF;
        }
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v] = val;
            return;
        }
        int m = (r + l) / 2;
        if (pos <= m) {
            update(v * 2, l, m, pos, val);
        } else {
            update(v * 2 + 1, m + 1, r, pos, val);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return -INF;
        }
        int m = (r + l) / 2;
        return max(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }

};

int n, h[N], b[N], dp[N];
segment_tree tree;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    tree.update(1, 0, n, 0, 0);
    vector<pair<int, int>> v;
    set<pair<int, int>> se;
    for (int i = 1; i <= n; i++) {
        while (!v.empty() && h[v.back().second] > h[i - 1]) {
            se.erase(v.back());
            v.pop_back();
        }

        int pr = b[i - 1];
        if (!v.empty()) {
            pr += tree.get(1, 0, n, v.back().second + 1, i - 1);
//            cout << tree.get(1, 0, n, v.back().second + 1, i - 1) << " " << v.back().second + 1 << " " << i - 1 << endl;
        } else if (i > 1) {
            pr += tree.get(1, 0, n, 0, i - 1);
        }
        v.push_back({pr, i - 1});
        se.insert({pr, i - 1});
        dp[i] = (--se.end())->first;
        tree.update(1, 0, n, i, dp[i]);
    }
//    for (int i = 1; i <= n; i++) {
//        cout << dp[i] << " ";
//    }
//    cout << endl;
    cout << dp[n];
}