#include <bits/stdc++.h>
#define int long long
#define ld long double
#define all(c) (c).begin(), (c).end()
#define pii pair <int, int>
#define pld pair <ld, ld>
#define vi vector <int>
#define vld vector <ld>
#define vpi vector <pii>
#define pb push_back
using namespace std;
const int N = 3e5, M = 2e3, lg = 20, inf = 2e9, mod = 1e9+7;

struct segment_tree{
    vi t, add;
    int n;
    segment_tree(int _n) {
        n = _n;
        t = vi(4 * n, -1e18);
        add = vi(4 * n, 0);
    }

    void push(int v, int l, int r) {
        if(!add[v])
            return;
        t[v] += add[v];
        if(l != r - 1) {
            add[2 * v] += add[v];
            add[2 * v + 1] += add[v];
        }
        add[v] = 0;
    }

    void update_pos(int v, int l, int r, int pos, int val) {
        push(v, l, r);
        if(l == r - 1) {
            t[v] = val;
            return;
        }
        int m = (l + r) / 2;
        if(pos < m)
            update_pos(2 * v, l, m, pos, val);
        else
            update_pos(2 * v + 1, m, r, pos, val);
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }

    void update_pos(int pos, int val) {
        update_pos(1, 0, n, pos, val);
    }

    void update(int v, int l, int r, int vl, int vr, int val) {
        push(v, l, r);
        if(l >= vr || vl >= r)
            return;
        if(l >= vl && r <= vr) {
            add[v] += val;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v, l, m, vl, vr, val);
        update(2 * v + 1, m, r, vl, vr, val);
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }
    void update(int vl, int vr, int val) {
        update(1, 0, n, vl, vr + 1, val);
    }

    int get(int v, int l, int r, int vl, int vr) {
        push(v, l, r);
        if(l >= vr || vl >= r)
            return -inf;
        if(l >= vl && r <= vr)
            return t[v];
        int m = (l + r) / 2;
        int m1 = get(2 * v, l, m, vl, vr);
        int m2 = get(2 * v + 1, m, r, vl, vr);
        return max(m1, m2);
    }
    int get(int l, int r) {
        return get(1, 0, n, l, r + 1);
    }

};

struct seg{
    int l, r, h, val;
};

int b[N], h[N], d[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> h[i];
    for (int i = 1; i <= n; i++)
        cin >> b[i];
    vector <seg> v;
    segment_tree T(n + 1);
    for (int i = 1; i <= n; i++) {
        v.pb({i, i, h[i], b[i]});
        T.update_pos(i, b[i] + d[i - 1]);
        while(v.size() > 1 && v.back().h < v[v.size() - 2].h) {
            seg s;
            T.update(v[v.size() - 2].l, v[v.size() - 2].r, -v[v.size() - 2].val + v.back().val);
            s.l = v[v.size() - 2].l;
            s.r = v[v.size() - 1].r;
            s.h = v.back().h;
            s.val = v.back().val;
            v.pop_back();
            v.pop_back();
            v.pb(s);
        }

        d[i] = T.get(1, i);
    }
    cout << d[n];
}

signed main() {
   // freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    solve();
}