#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <cstring>
#include <sstream>
#include <functional>
#include <unordered_set>
#include <array>
#include <deque>
#include <chrono>
#include <random>

#define err(x) {cerr << "["#x"]  " << (x) << '\n';}
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << (___) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << ((x)[___]) << ", "; cerr << "]\n";}
#define errf() {cerr << "\n\n";}
#define sq(x) ((x)*(x))

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

//mt19937 rng(random_device());
//mt19937 rng(chrono::steady_clock().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

// ::::::::::::::::::::::::::::::::::::;

const int N = 3e5 + 5;
const ll INF = 1e16;

ll tree[4 * N], lazy[4 * N];

inline void upd(int v, ll x) {
    tree[v] += x;
    lazy[v] += x;
}

inline void push(int v) {
    upd(2 * v, lazy[v]);
    upd(2 * v + 1, lazy[v]);
    lazy[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, ll x) {
    if (l > r) return;
    if (tl == l && tr == r)
        upd(v, x);
    else {
        int tm = (tl + tr) / 2;
        push(v);
        update(2 * v, tl, tm, l, min(r, tm), x);
        update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
}

ll get(int v, int tl, int tr, int l, int r) {
    if (l > r) return -INF;
    if (tl == l && tr == r)
        return tree[v];
    else {
        int tm = (tl + tr) / 2;
        push(v);
        return max(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
    }
}

ll dp[N], h[N], b[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> h[i];
    for (int i = 1; i <= n; ++i)
        cin >> b[i];

    dp[0] = 0;
    vector<int> st;
    for (int i = 1; i <= n; ++i) {
        while (!st.empty() && h[st.back()] >= h[i]) {
            int l = st.size() == 1 ? 0 : (st[st.size() - 2]);
            update(1, 0, n, l, st.back() - 1, -b[st.back()]);
            st.pop_back();
        }
        int l = st.empty() ? 0 : st.back();
        st.push_back(i);
        update(1, 0, n, l, i - 1, b[i]);

//        errv(st);
        dp[i] = get(1, 0, n, 0, i - 1);
//        err(dp[i]);
        update(1, 0, n, i, i, dp[i]);
    }
    cout << dp[n] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    return 0;
}

