#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <queue>
#include <deque>
#include <random>
#include <chrono>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <list>

using namespace std;

#define int long long
#define bint __int128
#define fi first
#define se second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define gcd(a, b) __gcd(a, b)
#define lcm(a, b) a/__gcd(a,b)*b

mt19937 rnd('m' + 'a' + 'n' + 'u' + 'l' + time(0));

const int MXN = 3e5, inf = 1e9, mod = 1e9 + 7;

template <typename T>
istream & operator >>(istream& in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}
template <typename T>
ostream & operator <<(ostream& out, vector<T> a) {
    for (auto &i : a) {
        out << i << ' ';
    }
    return out;
}
template <typename T, typename S>
istream & operator >>(istream& in, pair<T, S> &a) {
    in >> a.first >> a.second;
    return in;
}
template <typename T, typename S>
ostream & operator <<(ostream& out, pair<T, S> a) {
    out << a.first << ' ' << a.second;
    return out;
}

struct seg_tree {
    int n;
    vector<int> s, t;
    seg_tree(int _a) {
        n = _a;
        s.resize(4*n, 0);
        t.resize(4*n);
    }

    void push(int l, int r, int v) {
        if (t[v] == 0) return;
        s[v] += t[v];
        if (l != r-1) {
            t[v*2+1] += t[v];
            t[v*2+2] += t[v];
        }
        t[v] = 0;
    }

    int ask(int l, int r, int lx, int rx, int v) {
        push(l, r, v);
        if (l >= rx || r <= lx) return -1e15;
        if (l >= lx && r <= rx) return s[v];
        int m = (l + r) >> 1;
        return max(ask(l, m, lx, rx, v*2+1), ask(m, r, lx, rx, v*2+2));
    }
    int ask(int l, int r) {
        return ask(0, n, l, r+1, 0);
    }

    void upd(int l, int r, int lx, int rx, int v, int x) {
        push(l, r, v);
        if (l >= rx || r <= lx) return;
        if (l >= lx && r <= rx) {
            t[v] += x;
            push(l, r, v);
            return;
        }
        int m = (l + r) >> 1;
        upd(l, m, lx, rx, v*2+1, x);
        upd(m, r, lx, rx, v*2+2, x);
        s[v] = max(s[v*2+1], s[v*2+2]);
    }
    void upd(int l, int r, int x) {
        return upd(0, n, l, r+1, 0, x);
    }

};

void solut() {
    int n;
    cin >> n;
    vector<int> h(n), c(n);
    cin >> h >> c;
    c.insert(c.begin(), 0);
    h.insert(h.begin(), 2e9);
    n++;
    vector<int> dp(n);
    dp[0] = c[0];
    vector<int> left(n, -1), hh = h;
    hh.insert(hh.begin(), -1e15);
    vector<int> st = {0};
    for (int i = n; i >= 1; --i) {
        while (hh[st.back()] > hh[i]) {
            left[st.back()-1] = i-1;
            st.pop_back();
        }
        st.push_back(i);
    }

    seg_tree s(n);
    s.upd(0, 0, c[0]);
    vector<vector<int>> segs;
    segs.push_back({(int)-1, 0, c[0]});

    int X = 0;

    for (int i = 1; i < n; ++i) {
        int l = left[i];

        while (!segs.empty() && segs.back()[0] >= l) {
            auto d = segs.back();
            segs.pop_back();
            s.upd(max(0LL,d[0]), d[1], -d[2]);
        }

        segs.push_back({l, i-1, c[i]});
        s.upd(max(0LL,l), i-1, c[i]);


        dp[i] = s.ask(0, i-1);

        s.upd(i, i, dp[i]);
    }
    cout << dp[n-1];
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t-->0) solut();
}