#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll bpow(ll a, ll p, ll md) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1, md) * a) % md;
	ll b = bpow(a, p / 2, md);
	return (b * b) % md;
}

const ll SZ = 3e5 + 100, MOD = 1e9 + 7, INF = 1e9 * 1e9 + 100;

ll n;
vector<pair<ll, ll>> vec;

ll dp[SZ];
ll seg[SZ * 4];

void upd(int v, int l, int r, int askl, int askr, ll vl) {
	if (l >= askr || r <= askl) return;

	if (askl <= l && r <= askr) {
		seg[v] = max(seg[v], vl);
		return;
	}

	int mid = (l + r) / 2;
	upd(v * 2 + 1, l, mid, askl, askr, vl);
	upd(v * 2 + 2, mid, r, askl, askr, vl);
}

ll ask(int v, int l, int r, int pos, ll cur = -INF) {
	cur = max(cur, seg[v]);
	if (l == r - 1) {
		return cur;
	}
	else {
		int mid = (l + r) / 2;
		if (pos < mid) {
			return ask(v * 2 + 1, l, mid, pos, cur);
		}
		else {
			return ask(v * 2 + 2, mid, r, pos, cur);
		}
	}
}

ll seg2[SZ * 4];
void upd2(int v, int l, int r, int pos, ll vl) {
	if (l == r - 1) {
		seg2[v] = vl;
	}
	else {
		int mid = (l + r) / 2;
		if (pos < mid) {
			upd2(v * 2 + 1, l, mid, pos, vl);
		}
		else {
			upd2(v * 2 + 2, mid, r, pos, vl);
		}

		seg2[v] = max(seg2[v * 2 + 1], seg2[v * 2 + 2]);
	}
}

ll ask2(int v, int l, int r, int askl, int askr) {
	if (l >= askr || r <= askl) return -INF;

	if (askl <= l && r <= askr) {
		return seg2[v];
	}

	int mid = (l + r) / 2;
	return max(ask2(v * 2 + 1, l, mid, askl, askr), ask2(v * 2 + 2, mid, r, askl, askr));
}

int main() {
	fastInp;

	
	cin >> n;
	
	vec.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> vec[i].first;
	}

	for (int i = 0; i < n; i++) {
		cin >> vec[i].second;
	}

	for (int i = 0; i < n * 4 + 100; i++) {
		seg2[i] = -INF;
		seg[i] = -INF;
	}
	n++;
	vec.push_back({ INF, 0 });

	upd2(0, 0, n + 2, 0, 0);
	vector<pair<ll, ll>> st, st2;
	vector<ll> nxt(n + 1);

	for (int i = n; i >= 1; i--) {
		nxt[i] = n;
		while (st.size() > 0 && st.back().first > vec[i - 1].first) st.pop_back();
		if (st.size() > 0) nxt[i] = st.back().second;
		st.push_back({ vec[i - 1].first, i });
	}

	st.clear();

	for (int i = 1; i <= n; i++) {
		dp[i] = dp[i - 1] + vec[i - 1].second;
		while (st.size() > 0 && st.back().first > vec[i - 1].first) st.pop_back();

		if (st.size() > 0) {
			dp[i] = max(dp[i], ask2(0, 0, n + 2, st.back().second, i) + vec[i - 1].second);
		}
		else {
			dp[i] = max(dp[i], ask2(0, 0, n + 2, 0, i) + vec[i - 1].second);
		}

		dp[i] = max(dp[i], ask(0, 0, n + 2, i) + vec[i - 1].second);

		if (nxt[i] != i) {
			upd(0, 0, n + 2, i + 1, nxt[i] + 1, dp[i]);
		}

		st.push_back({ vec[i - 1].first, i });

		upd2(0, 0, n + 2, i, dp[i]);
	}

	cout << dp[n];

	return 0;
}