#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define all(a) (a).begin(), (a).end()
#define ld long double
#define pii pair<int, int>
#define int long long

const int inf = 1e18;


struct segment_tree {
	vector<int> tree;
	int n;
	segment_tree() {}

	segment_tree(int n_) {
		n = n_;
		tree.resize(4 * n, -inf);
	}

	void upd(int v, int tl, int tr, int pos, int val) {
		if (tl + 1 == tr) {
			tree[v] = val;
			return;
		}
		int tm = (tl + tr) >> 1;
		if (tm > pos) {
			upd(2 * v + 1, tl, tm, pos, val);
		} else {
			upd(2 * v + 2, tm, tr, pos, val);
		}
		tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
	}

	void upd(int pos, int val) {
		upd(0, 0, n, pos, val);
	}

	int get(int v, int tl, int tr, int l, int r) {
		if (tl >= r || tr <= l) return -inf;
		if (tl >= l && tr <= r) return tree[v];
		int tm = (tl + tr) >> 1;
		return max(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
	}
	int get(int l, int r) {
		return get(0, 0, n, l, r);
	}
};


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;
	vector<int> h(n);
	vector<int> b(n);

	for (int i = 0; i < n; i++) cin >> h[i];
	for (int i = 0; i < n; i++) cin >> b[i];

	segment_tree dp(n + 1);

	dp.upd(0, 0);

	vector<pii> up = {{-1, -inf}};

	for (int i = 0; i < n; i++) {
		while (up.size() > 1 && h[up.back().first] > h[i]) up.pop_back();
		int dp1 = dp.get(up.back().first + 1, i + 1) + b[i];
		// cout << dp1 << ' ';
		if (up.size() == 1) {
			dp1 = max(dp1, b[i]);
		} else {
			dp1 = max(dp1, up.back().second);
		}
		up.push_back({i, dp1});
		dp.upd(i + 1, dp1);
		// cout << dp1 << "    ";
	}
	// cout << '\n';

	cout << dp.get(n, n + 1) << '\n';
	return 0;
}
