#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;
//#define int long long

int binpow(int a, int n){
    if (n == 0) return 1;
    if (n%2 == 0){
        int b = binpow(a, n/2);
        return b*b;
    }
    return a*binpow(a, n-1);
}

int gcd(int a, int b){
    if (b == 0) return a;
    return gcd(b, a%b);
}

tuple<int, int, int> gcdex(int a, int b){
    if (b == 0) return {a, 1, 0};
    int x, y, g;
    tie(g, x, y) = gcdex(b, a%b);
    return {g, y, x-(a/b)*y};
}
const int SIZE = 3e5, INF = 1e9+7;
int t[4*SIZE];
vector<int> h;
vector<long long> dp;
long long MAXdp[4*SIZE];

void build(int v, int l, int r){
    if (l+1 == r) return void(t[v] = h[l]);
    int m = l+(r-l)/2;
    build(2*v+1, l, m);
    build(2*v+2, m, r);
    t[v] = min(t[2*v+1], t[2*v+2]);
}

int ask(int v, int l, int r, int askl, int askr){
    if (l >= askr || r <= askl) return INF;
    if (askl <= l && r <= askr) return t[v];
    int m = l+(r-l)/2;
    return min(ask(2*v+1, l, m, askl, askr), ask(2*v+2, m, r, askl, askr));
}

void build1(int v, int l, int r){
    if (l+1 == r) return void(MAXdp[v] = dp[l]);
    int m = l+(r-l)/2;
    build(2*v+1, l, m);
    build(2*v+2, m, r);
    t[v] = max(t[2*v+1], t[2*v+2]);
}

void change(int v, int l, int r, int pos, long long val){
    if (l+1 == r) return void(MAXdp[v] = val);
    int m = l+(r-l)/2;
    if (pos < m) change(2*v+1, l, m, pos, val);
    else change(2*v+2, m, r, pos, val);
    MAXdp[v] = max(MAXdp[2*v+1], MAXdp[2*v+2]);
}

long long ask1(int v, int l, int r, int askl, int askr){
    if (l >= askr || r <= askl) return -INF;
    if (askl <= l && r <= askr) return MAXdp[v];
    int m = l+(r-l)/2;
    return max(ask1(2*v+1, l, m, askl, askr), ask1(2*v+2, m, r, askl, askr));
}

int32_t main(){
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    h.resize(n);
    dp.resize(n, -INF);
    build1(0, 0, n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i){
        cin >> h[i];
    }
    build(0, 0, n);
    for (int i = 0; i < n; ++i){
        cin >> b[i];
    }
    dp[0] = b[0];
    change(0, 0, n, 0, dp[0]);
    for (int i = 1; i < n; ++i){
        dp[i] = dp[i-1]+b[i];
        int l = -1, r = i, m; //r = first bigger or equal to h[i];
        while (r-l > 1){
            m = (l+r)/2;
            if (ask(0, 0, n, m, i+1) >= h[i]) r = m;
            else l = m;
        }
        int l1 = r-1, r1 = i, m1;
        long long lol = ask1(0, 0, n, max((int)0, l1), r1);
        dp[i] = max(dp[i], lol+b[i]);
        dp[i] = max(dp[i], (l1 == -1 ? 0 : dp[l1])+b[i]);
        if (l1+1 != i) dp[i] = max(dp[i], dp[l1+1]+b[i]);
        if (r != 0) dp[i] = max({dp[i], dp[r-1]+b[i], dp[r-1]});
        change(0, 0, n, i, dp[i]);
    }
    cout << dp[n-1] << '\n';
    return 0;
}