#include <algorithm>
#include <iostream>
#include <math.h>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define int ll

//#define x first
//#define y second

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define vs vector<string>
#define pipii pair<int, pii>
#define piipi pair<pii, int>

const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;
const int N = 1e5;
const ll M = 1e9 + 7; //92359417

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

struct node {
    int max = -INF, p = 0;
};
vector<node> t;
void push(int v) {
    if (t[v].p) {
        int p = t[v].p;
        t[2 * v].max += p;
        t[2 * v + 1].max += p;
        t[2 * v].p += p;
        t[2 * v + 1].p += p;
        t[v].p = 0;
    }
}
void update(int v, int l, int r, int ql, int qr, int x) {
    if (l > qr || r < ql) return;
    if (l >= ql && r <= qr) {
        t[v].p += x;
        t[v].max += x;
        return;
    }
    push(v);
    int c = (l + r) / 2;
    update(2 * v, l, c, ql, qr, x); update(2 * v + 1, c + 1, r, ql, qr, x);
    t[v].max = max(t[2 * v].max, t[2 * v + 1].max);
}
void make(int v, int l, int r, int p, int x) {
    if (l > p || r < p) return;
    if (l == r) {
        t[v].max = x;
        return;
    }
    push(v);
    int c = (l + r) / 2;
    make(2 * v, l, c, p, x); make(2 * v + 1, c + 1, r, p, x);
    t[v].max = max(t[2 * v].max, t[2 * v + 1].max);
}
int get(int v, int l, int r, int ql, int qr) {
    if (l > qr || r < ql) return -INF;
    if (l >= ql && r <= qr) return t[v].max;
    push(v);
    int c = (l + r) / 2;
    return max(get(2 * v, l, c, ql, qr), get(2 * v + 1, c + 1, r, ql, qr));
}

void solve() {
    int n; cin >> n;
    vi h(n), a(n);
    for (int i = 0; i < n; ++i) cin >> h[i];
    for (int i = 0; i < n; ++i) cin >> a[i];
    vi dp(n + 1, -INF);
    vpii s;
    int start = 1;
    while (start <= n) start *= 2;
    t.resize(2 * start);
    make(1, 0, start - 1, 0, 0);
    for (int i = 0; i < n; ++i) {
        update(1, 0, start - 1, i, i, a[i]);
        while (s.size() && h[s.back().second] > h[i]) {
            int l = s.back().first;
            int r = s.back().second;
            int d = a[i] - a[r];
            update(1, 0, start - 1, l, r, d);
            s.pop_back();
        }
        if (s.size()) s.push_back({s.back().second + 1, i});
        else {
            s.push_back({ 0, i });
        }
        dp[i] = get(1, 0, start - 1, 0, i);
        make(1, 0, start - 1, i + 1, dp[i]);
    }
    cout << dp[n - 1] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}