#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

#define int long long
const int MAX_N = 3e5 + 1;
int h[MAX_N], b[MAX_N];
ll dp[MAX_N];


struct Node {
    int l, r, mx, sec_mx;
};


Node tree[4 * MAX_N];

void build(int v, int l, int r) {
    tree[v].l = l;
    tree[v].r = r;
    tree[v].mx = 0;
    tree[v].sec_mx = LLONG_MIN;
    if (r - l > 1) {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
    }
}


void set_val(int v, int indx, int val) {
    if (tree[v].l == indx && tree[v].r - tree[v].l == 1) {
        tree[v].mx = val;
        return;
    }
    if (indx < tree[2 * v].r)
        set_val(2 * v, indx, val);
    else
        set_val(2 * v + 1, indx, val);
    tree[v].mx = max(tree[2 * v].mx, tree[2 * v + 1].mx);
}


int get_mx(int v, int l, int r) {
    if (tree[v].l >= r || tree[v].r <= l)
        return 0;
    if (l <= tree[v].l && tree[v].r <= r)
        return tree[v].mx;
    return max(get_mx(2 * v, l, r), get_mx(2 * v + 1, l, r));
}


void set_sec_val(int v, int indx, int val) {
    if (tree[v].l == indx && tree[v].r - tree[v].l == 1) {
        tree[v].sec_mx = val;
        return;
    }
    if (indx < tree[2 * v].r)
        set_sec_val(2 * v, indx, val);
    else
        set_sec_val(2 * v + 1, indx, val);
    tree[v].sec_mx = max(tree[2 * v].sec_mx, tree[2 * v + 1].sec_mx);
}


int get_sec_mx(int v, int l, int r) {
    if (tree[v].l >= r || tree[v].r <= l)
        return LLONG_MIN;
    if (l <= tree[v].l && tree[v].r <= r)
        return tree[v].sec_mx;
    return max(get_sec_mx(2 * v, l, r), get_sec_mx(2 * v + 1, l, r));
}


void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> h[i];
    for (int i = 1; i <= n; ++i)
        cin >> b[i];

    build(1, 0, n + 1);

    dp[0] = 0;
    dp[1] = b[1];
    set_sec_val(1, 0, 0);
    set_val(1, h[1], 1);
    set_sec_val(1, 1, dp[1]);
    for (int i = 2; i <= n; ++i) {
        dp[i] = dp[i - 1] + b[i];
        int j = get_mx(1, 1, h[i]);
        if (j != 0) {
            dp[i] = max(dp[i], dp[j]);
            dp[i] = max(dp[i], dp[j - 1] + b[j]);
        }
        //cout << i << ' ' << j << ' ' << max(1ll, j - 1) << ' ' << i - 1 << endl;
        dp[i] = max(dp[i], get_sec_mx(1, j, i) + b[i]);
        if (j)
            dp[i] = max(dp[i], dp[j - 1] + b[j]);
        set_sec_val(1, i, dp[i]);
        set_val(1, h[i], i);
        //cout << j << '\n';
    }
    cout << dp[n];
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();

    return 0;
}
