#include <bits/stdc++.h>

/// #pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e10) + 123;

struct node {
    ll l, mid, r;
    ll mx;
    ll nxt;
    node *left, *right;
    node(ll l, ll r): l(l), r(r) {
        mid = (l + r) / 2;
        mx = -inf;
        nxt = 0;
        left = right = nullptr;
    }
};

void build(node *root) {
    if(root->l == root->r) {
        return;
    } else {
        root->left = new node(root->l, root->mid);
        root->right = new node(root->mid + 1, root->r);
        build(root->left);
        build(root->right);
    }
}

void push(node *root) {
    if(root->nxt == 0) return;

    if(root->left != nullptr) {
        root->left->nxt += root->nxt;
        root->right->nxt += root->nxt;
    }
    root->mx += root->nxt;
    root->nxt = 0;
}

void add_val(node *root, ll ql, ll qr, ll val) {
    push(root);

    if(root->r < ql || root->l > qr) {
        return;
    }
    if(ql <= root->l && root->r <= qr) {
        root->nxt += val;
        push(root);
        return;
    }

    add_val(root->left, ql, qr, val);
    add_val(root->right, ql, qr, val);
    root->mx = max(root->left->mx, root->right->mx);
}

ll get_mx(node *root, ll ql, ll qr) {
    push(root);

    if(root->r < ql || root->l > qr) {
        return -inf;
    }
    if(ql <= root->l && root->r <= qr) {
        return root->mx;
    }

    return max(get_mx(root->left, ql, qr),
               get_mx(root->right, ql, qr));
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> h, b;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        h.pb(cur);
    }
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        b.pb(cur);
    }

    node *root = new node(0, n - 1); /// 0'th position on index 1
    build(root);

    vector<pll> sack; /// <height, pos>
    sack.pb({0, -1});

    for(ll i = 0; i < n; i++) {
        ll left = i - 1;

        while(sack.size() > 0 && sack.back().first > h[i]) {
            ll right = sack.back().second - 1;
            sack.pop_back();
            left = sack.back().second;

            // cout << "seg " << left << " " << right << " " << -b[right + 1] << endl;

            add_val(root, left, right, -b[right + 1]);
        }
        sack.pb({h[i], i});

        add_val(root, i, i, inf);
        add_val(root, left, i - 1, b[i]);
        get_mx(root, i - 1, i - 1);
        ll val = max(b[sack[1].second], get_mx(root, 0, i - 1));

        add_val(root, i, i, val);

        if(i == n - 1) {
            cout << val << "\n";
            return;
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
