#include <bits/stdc++.h>

using namespace std;

#define int long long


class SegmentTree {
public:
	vector<int> a;
	int n;

	SegmentTree(int sz): n(sz), a(4 * sz) {}

	int get(int v, int vl, int vr, int l, int r) {
		if(vl == l && vr == r) {
			return a[v];
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return get(v * 2, vl, vm, l, r);
		} else if(l >= vm) {
			return get(v * 2 + 1, vm, vr, l, r);
		} else {
			return max(get(v * 2, vl, vm, l, vm), get(v * 2 + 1, vm, vr, vm, r));
		}
	}
	int get(int l, int r) {
		return get(1, 0, n, l, r);
	}
	int get(int i) {
		return get(i, i + 1);
	}

	void set(int v, int vl, int vr, int i, int x) {
		if(vr - vl == 1) {
			a[v] = x;
			return;
		}
		int vm = (vl + vr) / 2;
		if(i < vm) {
			set(v * 2, vl, vm, i, x);
		} else {
			set(v * 2 + 1, vm, vr, i, x);
		}
		a[v] = max(a[v * 2], a[v * 2 + 1]);
	}
	void set(int i, int x) {
		set(1, 0, n, i, x);
	}
};


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> h(n);
	for(int i = 0; i < n; i++) {
		cin >> h[i];
	}

	vector<int> b(n);
	for(int i = 0; i < n; i++) {
		cin >> b[i];
	}

	vector<int> stck;

	vector<int> dp(n, -1000000000000LL);
	SegmentTree dpst(n);
	for(int i = 0; i < n; i++) {
		while(stck.size() > 0 && h[stck.back()] >= h[i]) {
			stck.pop_back();
		}

		int prevlower;
		if(stck.size() > 0) {
			prevlower = stck.back();
			dp[i] = dp[prevlower];
		} else {
			prevlower = -1;
		}
		stck.push_back(i);

		if(prevlower == -1) {
			dp[i] = b[i];
			prevlower = 0;
		}
		if(prevlower < i) {
			dp[i] = max(dp[i], b[i] + dpst.get(prevlower, i));
		}
		dpst.set(i, dp[i]);
	}

	cout << dp.back() << endl;

	return 0;
}