#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define pii pair<int, int>

using namespace std;

const int inf = 1e16;

struct segtree_node {
	int dp; // dp_max;  // dp
	int h, h_max; // h_min;  // h && min_h
	int d; // d_max;  // delta
	int push;
	int res;  // dp + d
	segtree_node() {
		dp = -inf;
		h = inf;
		h_max = inf;
		d = 0;
		push = 0;
		res = -inf;
	}
	segtree_node(int dp_) {
		dp = dp_;
		h = inf;
		h_max = inf;
		d = 0;
		push = 0;
		res = -inf;
	}
};

struct segtree {
	int n;
	vector<segtree_node> tree;

	void upd(int v) {
		int l = v * 2 + 1, r = v * 2 + 2;
		tree[v].dp = max(tree[l].dp, tree[r].dp);
		tree[v].d = max(tree[l].d, tree[r].d);
		tree[v].h = min(tree[l].h, tree[r].h);
		tree[v].h_max = max(tree[l].h_max, tree[r].h_max);
		tree[v].res = max(tree[l].res, tree[r].res);
	}

	void push(int v) {
		int l = v * 2 + 1, r = v * 2 + 2;
		if (tree[v].push) {
			tree[l].d = tree[v].d;
			tree[l].h = tree[v].h;
			tree[l].h_max = tree[v].h_max;
			tree[l].push = 1;
			tree[l].res = tree[l].dp + tree[l].d;

			tree[r].d = tree[v].d;
			tree[r].h = tree[v].h;
			tree[r].h_max = tree[v].h_max;
			tree[r].push = 1;
			tree[r].res = tree[r].dp + tree[r].d;
		}
		tree[v].push = 0;
	}

	segtree() {}
	segtree(int n_) {
		n = n_;
		tree.assign(4 * n, segtree_node());
	}

	void put(int v, int tl, int tr, int l, int r, int d, int h) {
		if (tl + 1 != tr) push(v);
		if (l <= tl && tr <= r && tree[v].h > h) {
			tree[v].d = d;
			tree[v].h = h;
			tree[v].h_max = h;
			tree[v].res = tree[v].dp + d;
			if (tl + 1 != tr) tree[v].push = 1;
			return;
		}
		if (r <= tl || tr <= l || tree[v].h_max < h) return;
		int tm = (tl + tr) / 2;
		put(v * 2 + 1, tl, tm, l, r, d, h);
		put(v * 2 + 2, tm, tr, l, r, d, h);
		upd(v);
	}

	void put(int d, int h, int l, int r) {
		put(0, 0, n, l, r + 1, d, h);
	}

	void put_dp(int v, int l, int r, int p, int dp) {
		if (l + 1 != r) push(v);
		if (l + 1 == r) {
			tree[v].dp = dp;
			return;
		}
		int m = (l + r) / 2;
		if (p < m) {
			put_dp(v * 2 + 1, l, m, p, dp);
		} else {
			put_dp(v * 2 + 2, m, r, p, dp);
		}
		upd(v);
	}

	void put_dp(int p, int dp) {
		put_dp(0, 0, n, p, dp);
	}
};

int n;
vector<int> h, b;
segtree tree;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	h.resize(n);
	b.resize(n);
	for (auto &e : h) cin >> e;
	for (auto &e : b) cin >> e;
	tree = segtree(n);
	tree.put_dp(0, b[0]);

	int hh = h[0], dd = b[0];
	int mx;
	for (int i = 1; i < n; i++) {
		if (h[i] < hh) {
			hh = h[i];
			dd = b[i];
		}
		tree.put(b[i], h[i], 0, i - 1);
		mx = max(dd, tree.tree[0].res);
		// cout << "(" << b[i] << " " << tree.tree[0].res << ") " << mx << "\n";
		tree.put_dp(i, mx);
	}
	if (n == 1) mx = b[0];
	cout << mx << "\n";
	return 0;
}
