#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <utility>
#include <numeric>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <bitset>
#include <cstdlib>
#include <cassert>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

const int INF = 1e9;
const long long INFINF = 1e18;

vector<int> sth;
vector<long long> stdp;

void buildh(int v, int left, int right, vector<int> &h) {
    if (right - left == 1) {
        sth[v] = h[left];
        return;
    }
    int mid = (left + right) / 2;
    buildh(v * 2 + 1, left, mid, h);
    buildh(v * 2 + 2, mid, right, h);
    sth[v] = min(sth[v * 2 + 1], sth[v * 2 + 2]);
}

int getvalh(int v, int left, int right, int L, int R) {
    if (R <= left || right <= L) {
        return INF;
    }
    if (L <= left && right <= R) {
        return sth[v];
    }
    int mid = (left + right) / 2;
    return min(getvalh(v * 2 + 1, left, mid, L, R), getvalh(v * 2 + 2, mid, right, L, R));
}

void updatedp(int v, int left, int right, int ind, long long val) {
    if (ind < left || right <= ind) {
        return;
    }
    if (right - left == 1) {
        stdp[v] = val;
        return;
    }
    int mid = (left + right) / 2;
    updatedp(v * 2 + 1, left, mid, ind, val);
    updatedp(v * 2 + 2, mid, right, ind, val);
    stdp[v] = max(stdp[v * 2 + 1], stdp[v * 2 + 2]);
}

long long getvaldp(int v, int left, int right, int L, int R) {
    if (R <= left || right <= L) {
        return -INFINF;
    }
    if (L <= left && right <= R) {
        return stdp[v];
    }
    int mid = (left + right) / 2;
    return max(getvaldp(v * 2 + 1, left, mid, L, R), getvaldp(v * 2 + 2, mid, right, L, R));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    vector<long long> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    sth.resize(4 * n, INF);
    buildh(0, 0, n, h);
    vector<pair<int, long long>> stack;
    vector<vector<long long>> dp(n + 1, {-INFINF, -INFINF});
    dp[0] = {0, 0};
    dp[1][0] = b[0];
    stack.emplace_back(1, dp[1][0]);
    stdp.resize((n + 1) * 4, -INFINF);
    updatedp(0, 0, n + 1, 0, 0);
    updatedp(0, 0, n + 1, 1, b[0]);
    for (int i = 2; i <= n; ++i) {
        int left = 0, right = i;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            int val = getvalh(0, 0, n, mid - 1, i);
            if (val == h[i - 1]) {
                right = mid;
            }
            else {
                left = mid;
            }
        }
        dp[i][0] = getvaldp(0, 0, n + 1, left, i) + b[i - 1];
        while (!stack.empty() && h[stack.back().first - 1] > h[i - 1]) {
            stack.pop_back();
        }
        if (!stack.empty()) {
            dp[i][1] = stack.back().second;
        }
        stack.emplace_back(i, (stack.empty() ? dp[i][0] : max(dp[i][0], stack.back().second)));
        updatedp(0, 0, n + 1, i, max(dp[i][0], dp[i][1]));
    }
    cout << max(dp[n][0], dp[n][1]) << "\n";

    return 0;
}