#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define gcd __gcd
#define int long long

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 3e5, INF = 2e9;

int ST[MAXN * 4];

void update(int id, int val, int v = 0, int vl = 0, int vr = MAXN) {
    if (vr - vl == 1) {
        ST[v] = val;
        return;
    }
    int vm = (vl + vr) / 2;
    if (id < vm) {
        update(id, val, v * 2 + 1, vl, vm);
    } else {
        update(id, val, v * 2 + 2, vm, vr);
    }
    ST[v] = max(ST[v * 2 + 1], ST[v * 2 + 2]);
}

int get(int l, int r, int v = 0, int vl = 0, int vr = MAXN) {
    if (l <= vl && vr <= r) {
        return ST[v];
    }
    if (r <= vl || vr <= l) {
        return -INF;
    }
    int vm = (vl + vr) / 2;
    return max(get(l, r, v * 2 + 1, vl, vm), get(l, r, v * 2 + 2, vm, vr));
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> h(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    stack<int> st;
    vector<int> left(n, -1);
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && h[st.top()] > h[i]) {
            left[st.top()] = i;
            st.pop();
        }
        st.emplace(i);
    }
    vector<int> dp(n + 1, -INF);
    dp[0] = 0;
    update(0, dp[0]);
    for (int i = 0; i < n; i++) {
        if (left[i] == -1) {
            dp[i + 1] = get(0, i + 1) + b[i];
        } else {
            dp[i + 1] = get(left[i] + 1, i + 1) + b[i];
            dp[i + 1] = max(dp[i + 1], dp[left[i] + 1]);
        }
        update(i + 1, dp[i + 1]);
    }
    cout << dp.back() << '\n';
    return 0;
}
