#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 4 * 128 * 1024;

// segtree max
vector<int> st_max(2 * N, -1);

void st_max_set(int i, int x) {
    i += N;
    st_max[i] = x;

    i /= 2;
    while (i > 0) {
        st_max[i] = max(st_max[2 * i], st_max[2 * i + 1]);
        i /= 2;
    }
}

int internal_st_max_get(int tv, int tl, int tr, int ql, int qr) {
    if (tr <= ql || qr <= tl) {
        return -1;
    }

    if (ql <= tl && tr <= qr) {
        return st_max[tv];
    }

    int tm = (tl + tr) / 2;
    return max(
            internal_st_max_get(2 * tv, tl, tm, ql, qr),
            internal_st_max_get(2 * tv + 1, tm, tr, ql, qr)
    );
}

int st_max_get(int l, int r) {
    return internal_st_max_get(1, 0, N, l, r);
}

const int INF = 1000000000000000000;
// segtree max2
vector<int> st_max2(2 * N, -INF);

void st_max2_set(int i, int x) {
    i += N;
    st_max2[i] = x;

    i /= 2;
    while (i > 0) {
        st_max2[i] = max(st_max2[2 * i], st_max2[2 * i + 1]);
        i /= 2;
    }
}

int internal_st_max2_get(int tv, int tl, int tr, int ql, int qr) {
    if (tr <= ql || qr <= tl) {
        return -INF;
    }

    if (ql <= tl && tr <= qr) {
        return st_max2[tv];
    }

    int tm = (tl + tr) / 2;
    return max(
            internal_st_max2_get(2 * tv, tl, tm, ql, qr),
            internal_st_max2_get(2 * tv + 1, tm, tr, ql, qr)
    );
}

int st_max2_get(int l, int r) {
    return internal_st_max2_get(1, 0, N, l, r);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n;
    cin >> n;

    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        h[i]--;
    }

    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<int> prev_less(n);
    for (int i = 0; i < n; ++i) {
        prev_less[i] = st_max_get(0, h[i]);
//        cerr << prev_less[i] << endl;
        st_max_set(h[i], i);
    }
//    cerr << endl;

    vector<int> dp(n);
    dp[0] = b[0];
    st_max2_set(0, b[0]);

    for (int i = 1; i < n; ++i) {
        int prev = prev_less[i];
//        cerr << prev << endl;

        int l = prev + 1;

        int cur;

        if (prev == -1) {
            cur = b[i];
        } else {
            cur = dp[prev];
        }
        if (l != i) {
            cur = max(cur, st_max2_get(l, i) + b[i]);
        } else {
            cur = max(cur, dp[prev] + b[i]);
        }
        dp[i] = cur;
        st_max2_set(i, cur);
    }
//    for (int i = 0; i < n; ++i) {
//        cerr << dp[i] << ' ';
//    }
//    cerr << endl;
    cout << dp[n - 1];
}
