/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma GCC optimize("Ofast")
//#pragma GCC target ("avx2")

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

const int N = 3e5 + 10, inf = 1e18;
int t[4 * N], add[4 * N];

void build(int v, int l, int r) {
    if (l == r - 1) {
        t[v] = -inf;
        add[v] = -inf;
    } else {
        int mid = (r + l) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = -inf;
        add[v] = -inf;
    }
}

void push(int v, int l, int r) {
    t[v] = max(t[v], add[v]);
    if (l != r - 1) {
        add[2 * v + 1] = max(add[2 * v + 1], add[v]);
        add[2 * v + 2] = max(add[2 * v + 2], add[v]);
    }
    add[v] = -inf;
}

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (tl <= l && tr >= r) {
        add[v] = max(add[v], val);
        push(v, l, r);
        return;
    }
    if (tl >= r || tr <= l)
        return;
    int mid = (r + l) / 2;
    update(2 * v + 1, l, mid, tl, tr, val);
    update(2 * v + 2, mid, r, tl, tr, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int tl, int tr) {
    push(v, l, r);
    if (tl <= l && tr >= r)
        return t[v];
    if (tl >= r || tr <= l)
        return -inf;
    int mid = (r + l) / 2;
    return max(get(2 * v + 1, l, mid, tl, tr), get(2 * v + 2, mid, r, tl, tr));
}

void solve() {
    int n;
    cin >> n;
    int a[n + 1], w[n + 1];
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    for (int i = 1; i <= n; i++)
        cin >> w[i];
    int l[n + 1], r[n + 1];
    vector<int> v;
    for (int i = 1; i <= n; i++) {
        while (!v.empty() && a[v.back()] > a[i])
            v.pop_back();
        if (v.empty()) {
            l[i] = 0;
        } else {
            l[i] = v.back();
        }
        v.pb(i);
    }
    v.clear();
    for (int i = n; i >= 1; i--) {
        while (!v.empty() && a[v.back()] > a[i])
            v.pop_back();
        if (v.empty()) {
            r[i] = n + 1;
        } else {
            r[i] = v.back();
        }
        v.pb(i);
    }
    build(0, 0, N);
//    for (int j = 0; j <= n; j++)
//        cout << get(0, 0, N, j, j + 1) << ' ';
//    cout << endl;
    update(0, 0, N, 0, 1, 0);
//    for (int j = 0; j <= n; j++)
//        cout << get(0, 0, N, j, j + 1) << ' ';
//    cout << endl;
    for (int i = 1; i <= n; i++) {
        int mx = get(0, 0, N, l[i], i);
        update(0, 0, N, i, r[i], mx + w[i]);
//        for (int j = 0; j <= n; j++)
//            cout << get(0, 0, N, j, j + 1) << ' ';
//        cout << endl;
    }
    cout << get(0, 0, N, n, n + 1) << endl;
}

signed main() {
    ios
//    open("anime.in", "anime.out")
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}