#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define int long long
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n;
int h[SZ];
int b[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
}

struct node {
    int x = 0, add = 0;
};

int len;
node t[4 * SZ];

void push(int cur) {
    t[cur].x += t[cur].add;
    if (cur < len) {
        t[cur * 2].add += t[cur].add;
        t[cur * 2 + 1].add += t[cur].add;
    }
    t[cur].add = 0;
}

void update(int k, int cur, int l, int r, int vl = 0, int vr = len) {
    push(cur);
    if (r <= vl || vr <= l) return;
    if (l <= vl && vr <= r) {
        t[cur].add += k;
        push(cur);
        return;
    }
    update(k, cur * 2, l, r, vl, (vl + vr) >> 1);
    update(k, cur * 2 + 1, l, r, (vl + vr) >> 1, vr);
    t[cur].x = max(t[cur * 2].x, t[cur * 2 + 1].x);
}

int get(int cur, int l, int r, int vl = 0, int vr = len) {
    push(cur);
    if (r <= vl || vr <= l) return -inf;
    if (l <= vl && vr <= r) return t[cur].x;
    int a = get(cur * 2, l, r, vl, (vl + vr) >> 1);
    int b = get(cur * 2 + 1, l, r, (vl + vr) >> 1, vr);
    return max(a, b);
}

void solve() {
    len = (1 << 19);

    update(b[0], 1, 0, 1);
    vector<int> mn;
    mn.push_back(0);
    for (int i = 1; i < n; ++i) {
        while (!mn.empty() && h[mn.back()] > h[i]) {
            int j = mn.back();
            int k;
            if (mn.size() == 1) {
                k = 0;
            } else {
                k = mn[mn.size() - 2];
            }

            update(-b[j], 1, k, j);
            mn.pop_back();
        }

        int k = mn.empty() ? 0 : mn.back();
        update(b[i], 1, k, i);
        mn.push_back(i);

        int x = get(1, 0, i);
        update(max(x, b[mn[0]]), 1, i, i + 1);
    }

    cout << get(1, n - 1, n) << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}