#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int MAX_N = 3e5 + 228;
const int INF = 1e16 + 7;

int h[MAX_N];
int b[MAX_N];
int nearestRightLess[MAX_N];
int nearestLeftLess[MAX_N];

int segtree[4 * MAX_N + 228];


int get(int ql, int qr, int v = 0, int l = 0, int r = MAX_N) {
    if (ql >= r || qr <= l) {
        return -INF;
    }
    if (ql <= l && r <= qr) {
        return segtree[v];
    }
    int m = (l + r) / 2;
    return max(get(ql, qr, 2 * v + 1, l, m), get(ql, qr, 2 * v + 2, m, r));
}

void update(int index, int value, int v = 0, int l = 0, int r = MAX_N) {
    if (l + 1 == r) {
        segtree[v] = value;
        return;
    }
    int m = (l + r) / 2;
    if (index < m) {
        update(index, value, 2 * v + 1, l, m);
    } else {
        update(index, value, 2 * v + 2, m, r);
    }
    segtree[v] = max(segtree[2 * v + 1], segtree[2 * v + 2]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    fill(segtree, segtree + 4 * MAX_N + 228, -INF);
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<int> indicesStack;
    for (int i = 0; i < n; i++) {
        while (!indicesStack.empty() && h[indicesStack.back()] > h[i]) {
            nearestRightLess[indicesStack.back()] = i;
            indicesStack.pop_back();
        }
        indicesStack.push_back(i);
    }
    for (int i : indicesStack) {
        nearestRightLess[i] = n;
    }
    indicesStack.clear();
    for (int i = n - 1; i >= 0; i--) {
        while (!indicesStack.empty() && h[indicesStack.back()] > h[i]) {
            nearestLeftLess[indicesStack.back()] = i;
            indicesStack.pop_back();
        }
        indicesStack.push_back(i);
    }
    for (int i : indicesStack) {
        nearestLeftLess[i] = -1;
    }
    set<pair<int, int>, greater<pair<int, int>>> maximum;
    maximum.insert({0, 0});
    vector<vector<int>> ending(n + 1);
    update(0, 0);
    ending[0] = {0};
    for (int i = 0; i < n; i++) {
        int cur_dp = (*maximum.begin()).first + b[i];
        cur_dp = max(cur_dp, get(nearestLeftLess[i] + 1, i + 1) + b[i]);
        update(i + 1, cur_dp);
        int nr = nearestRightLess[i];
        //cout << "UPDATING INDEX " << i << " SEGMENT " << i + 1 << ' ' << nr << endl;
        //updateSegment(i + 1, nr + 1, cur_dp);
        maximum.insert({cur_dp, nr});
        ending[nr].push_back(cur_dp);
        for (int j : ending[i]) {
            maximum.erase({j, i});
        }
    }
    cout << (*maximum.begin()).first << endl;
}
