#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <stack>
#include <queue>
#include <deque>
using namespace std;
#define int long long

vector <int> divisors(int n) {
    vector <int> ans;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            ans.push_back(i);
            ans.push_back(n / i);
        }
    }
    sort(ans.rbegin(), ans.rend());
    return ans;
}

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

class SegTree {
    int n;
    vector <int> t;
public:
    SegTree(vector <int> a) {
        this->n = a.size();
        t.resize(2 * n);
        for (int i = 0; i < n; ++i) {
            t[i + n] = a[i];
        }
        for (int i = n - 1; i > 0; --i) {
            t[i] = max(t[2 * i], t[2 * i + 1]);
        }
    }
    void update(int pos, int val) {
        t[pos + n] = val;
        for (int i = (pos + n) / 2; i > 0; i /= 2) {
            t[i] = max(t[2 * i], t[2 * i + 1]);
        }
    }

    int query(int l, int r) {
        l += n, r += n;
        int ans = -1e10;
        while (l <= r) {
            if (l % 2 == 1) {
                ans = max(ans, t[l++]);
            }
            if (r % 2 == 0) {
                ans = max(ans, t[r--]);
            }
            l /= 2, r /= 2;
        }
        return ans;
    }
};


void solve() {
    int n;
    cin >> n;
    vector <int> h(n), b(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    deque <pair <int, int>> st;
    SegTree t(d);
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && h[i] < h[st.back().first]) {
            st.pop_back();
        }
        int prev = st.empty() ? -1e10 : st.back().second;
        // if h[i] is last min
        // then sum = d[j] + b[i], j in [st.back().second; i]
        if (st.empty()) {
            st.push_back({i, b[i] + max(0ll, t.query(0, i - 1))});
        } else {
            int ind = st.back().first;
//            int mx = -1e10;
//            for (int j = ind; j < i; ++j) {
//                if (d[j] > mx) {
//                    mx = d[j];
//                }
//            }
            st.push_back({i, max(prev, b[i] + t.query(ind, i - 1))});
        }



        d[i] = st.back().second;
        t.update(i, d[i]);
    }
    cout << d[n - 1] << "\n";
}

int32_t main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
        cout << "\n";
    }
}