#include<bits/stdc++.h>

using namespace std;

string tostr(string s) {
    string res = "";
    res.push_back('"');
    res += s;
    res.push_back('"');
    return res;
}

string tostr(char c) {
    string res = "";
    res += "'";
    res.push_back(c);
    res += "'";
    return res;
}

string tostr(long long x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + (x % 10));
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

string tostr(int x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + x % 10);
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

template<typename A, typename B>
string tostr(pair<A, B> a) {
    return "{" + tostr(a.first) + ", " + tostr(a.second) + "}";
}

template<typename A>
string tostr(vector<A> a) {
    string res = "{";
    bool f = false;
    for (auto x : a) {
        if (!f) {
            f = true;
        }
        else {
            res += ", ";
        }
        res += tostr(x);
    }
    res += "}";
    return res;
}

#define debug(x) cout << #x << " = " << tostr(x) << endl
#define int long long
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> dist(n, vector<int> (n, 1e18));
    vector<vector<int>> d(n, vector<int> (n, -1));
    vector<vector<int>> good(n, vector<int> (n, 0));
    for (int i = 0; i < n; i++) dist[i][i] = 0;
    for (int i = 0; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        d[x][y] = w;
        d[y][x] = w;
        dist[x][y] = dist[y][x] = w;
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (dist[i][k] != (int) 1e18 && dist[k][j] != (int) 1e18) {
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }
    }
    //debug(dist);
    vector<vector<int>> dp(n, vector<int> (n, 0));
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        dp[x][y] = dp[y][x] = w;
    }
    for (int A = 0; A < n; A++) {
        vector<int> flex(n, -1e18);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                flex[i] = max(flex[i], dp[A][j] - dist[i][j]);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                if (d[i][j] == -1) continue;
                int res = flex[j] - dist[A][i] - d[i][j];
                if (res >= 0) good[i][j]++;
            }
        }
    }
    //debug(good);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (good[i][j]) ans++;
        }
    }
    cout << ans;
}
