//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse42,avx,bmi,popcnt")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <cstdio>
#include <climits>
#include <cmath>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

int main()
{
	int n, m; std::cin >> n >> m;
	//complete graph on 600 vertices
	//e is useful if d[a,u]+len(e)+d[b,v] <= l for some a,b,l triple in the input
	//duplicate all triples to find rotated edges
	//to check if an edge is useful:
	//iterate over a
	//check for a b such that {d[a,u] + len(e)} + d[b, v] <= l[a,b]
	//				^constant
	//find b that minimizes d[b,v]-l[a,b]
	//for each a,v precalculate such a b
	int64_t inf = 601ll * int64_t(1e9);
	std::vector<std::vector<int64_t>> dist(n, std::vector<int64_t>(n, inf));
	std::vector<std::vector<int64_t>> o_dist(n, std::vector<int64_t>(n, inf));
	for(int i = 0; i < m; i++)
	{
		int u, v, w; scanf("%d%d%d", &u, &v, &w); u--; v--;
		dist[u][v] = w;
		dist[v][u] = w;
		o_dist[u][v] = w;
		o_dist[v][u] = w;
	}
	for(int i = 0; i < n; i++)
		o_dist[i][i] = dist[i][i] = 0;
	std::vector<std::vector<int64_t>> max_dist(n, std::vector<int64_t>(n, 0));
	int q; std::cin >> q;
	for(int i = 0; i < q; i++)
	{
		int u, v, w; scanf("%d%d%d", &u, &v, &w); u--; v--;
		max_dist[u][v] = w;
		max_dist[v][u] = w;
	}
	for(int k = 0; k < n; k++)
	for(int i = 0; i < n; i++)
	for(int j = 0; j < n; j++)
		dist[i][j] = std::min(dist[i][j], dist[i][k] + dist[k][j]);
	//for each a,v find b that maximizes l[a,b]-d[v,b]
	std::vector<std::vector<int>> lookup(n, std::vector<int>(n));
	for(int a = 0; a < n; a++)
	for(int v = 0; v < n; v++)
	{
		int64_t best = -2*inf;
		for(int b = 0; b < n; b++)
		{
			int64_t nval = max_dist[a][b] - dist[b][v];
			if(nval > best)
				best = nval;
		}
		//printf("lookup[a=%d][v=%d]=%lld\n", a, v, best);
		lookup[a][v] = best;
	}
	int ans = 0;
	for(int u = 0; u < n; u++)
	for(int v = u + 1; v < n; v++)
	{
		//check for a,b such that {d[a,u] + len(e)} <= l[a,b] - d[b, v]
		if(o_dist[u][v] >= inf) continue;
		bool ok = false;
		for(int a = 0; a < n; a++)
		{
			int64_t best_rhs = lookup[a][v];
			int64_t lhs = dist[a][u] + o_dist[u][v];
			if(best_rhs < -inf-100) continue;
			if(lhs >= inf) continue;
			if(lhs <= best_rhs) { ok = true; break; }
		}
		//printf("u=%d, v=%d, ok=%d\n", u, v, ok);
		if(ok) ans++;
	}
	printf("%d\n", ans);
}
