#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

long long d[600][600];
const long long INF = 1e18;

vector<pair<int, long long>> edges[600];
vector<pair<int, long long>> paths[600];

int main(){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i)
    fill(d[i], d[i] + n, INF);
  for (int i = 0; i < n; ++i)
    d[i][i] = 0;
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    edges[a - 1].emplace_back(b - 1, c);
    edges[b - 1].emplace_back(a - 1, c);
    d[a - 1][b - 1] = d[b - 1][a - 1] = c;
  }
  for (int k = 0; k < n; ++k) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j)
        d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
    }
  }
  int q;
  cin >> q;
  for (int i = 0; i < q; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    paths[a - 1].emplace_back(b - 1, c);
    paths[b - 1].emplace_back(a - 1, c);
  }
  int ans = 0;
  for (int a = 0; a < n; ++a) {
    vector<long long> cur_mx(n, -INF);
    for (int u = 0; u < n; ++u) {
      for (auto t : paths[u])
        cur_mx[t.first] = max(cur_mx[t.first], t.second - d[u][a]);
    }
    for (auto t : edges[a]) {
      bool ok = false;
      for (int v = 0; v < n; ++v) {
        if (t.second + d[t.first][v] <= cur_mx[v])
          ok = true;
      }
      ans += ok;
    }
  }
  cout << ans / 2 << '\n';
  return 0;
}
