#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll
ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll bpow(ll a, ll p, ll md) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1, md) * a) % md;
	ll b = bpow(a, p / 2, md);
	return (b * b) % md;
}

const ll SZ = 605, MOD = 1e9 + 7, INF = 1e9 * 1e5 + 100;

ll n, m;

ll dist[SZ][SZ], dist2[SZ][SZ];
ll dsu[SZ];

struct edge {
	ll u, v, c;
};

vector<edge> edges;
vector<edge> check, mst;

ll find(int v) {
	if (dsu[v] == v) return v;
	else return dsu[v] = find(dsu[v]);
}

void uni(int v, int u) {
	v = find(v);
	u = find(u);
	if (u != v) {
		dsu[u] = v;
	}
}

ll good(edge e) {
	return e.c <= dist2[e.u][e.v];
	ll f = 0;
	check = mst;

	for (auto c : check) {
		if (dist[e.u][c.v] + dist[e.v][c.u] + e.c <= c.c) {
			f = 1;
		}
		if (dist[e.u][c.u] + dist[e.v][c.v] + e.c <= c.c) {
			f = 1;
		}
	}


	return f;
}

bool cmp(edge e1, edge e2) {
	return e1.c < e2.c;
}
signed main() {
	fastInp;

	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		dsu[i] = i;
		for (int j = 0; j < n; j++) dist[i][j] = INF;
		dist[i][i] = 0;
	}
	for (int i = 0; i < m; i++) {
		ll u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		dist[u][v] = c;
		dist[v][u] = c;
		edges.push_back({ u, v, c });
	}

	for (int k = 0; k < n; k++) {
		for (int j = 0; j < n; j++) {
			for (int i = 0; i < n; i++) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}

	ll q;
	cin >> q;

	set<tuple<ll, ll, ll>> st;
	while (q--) {
		ll u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		check.push_back({ u, v, c });
		dist2[u][v] = c;
		dist2[v][u] = c;
		
	}

	for (int k = 0; k < n; k++) {
		for (int j = 0; j < n; j++) {
			for (int i = 0; i < n; i++) {
				dist2[i][k] = max(dist2[i][k], dist2[i][j] - dist[j][k]);
				dist2[k][j] = max(dist2[k][j], dist2[i][j] - dist[i][k]);
				//dist2[i][j] = max(dist2[i][j], dist2[i][k] + dist2[k][j]);
			}
		}
	}

	ll ans = 0;
	for (auto c : edges) {
		ans += good(c);
	}

	cout << ans;
	
	return 0;
}