#include <bits/stdc++.h>
#include <immintrin.h>

using namespace std;

void IO(){
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

template <typename T, typename D>
istream& operator>>(istream& in, pair<T, D>& a) {
    in >> a.first >> a.second;
    return in;
}

template <typename T, typename D>
ostream& operator<<(ostream& out, const pair<T, D>& a) {
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}


typedef long long ll;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(x) ((int)x.size())
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>
#define mod(x, m) ((x % m + m) % m)
#define eb emplace_back
#define maxq(a, b) a = max(a, (b))
#define minq(a, b) a = min(a, (b))

const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const long double PI = acos(-1);
auto seed = time(NULL);
mt19937 rnd(seed);

#define int ll

const int MAXN = 600 + 15;

int dist[MAXN][MAXN];
int edge[MAXN][MAXN];
int dp[MAXN][MAXN];
bool cool[MAXN][MAXN];
int query[MAXN][MAXN];
int n, m;

void Func() {
    memset(dp, -1, sizeof(dp));
    for (int v = 1; v <= n; ++v) {
        for (int y = 1; y <= n; ++y) {
            for (int u = 1; u <= n; ++u) {
                if (query[v][u] == -1 || dist[y][u] == -1) {continue;}
                int l = query[v][u];
                int me = l - dist[y][u];
                if (dp[v][y] == -1 || query[v][dp[v][y]] - dist[y][dp[v][y]] < me) {
                    dp[v][y] = u;
                }
            }
        }
    }
    for (int x = 1; x <= n; ++x) {
        for (int y = x + 1; y <= n; ++y) {
            if (edge[x][y] == -1) {continue;}
            for (int v = 1; v <= n; ++v) {
                if (dist[x][v] == -1) {continue;}
                int u = dp[v][y];
                if (u == -1) {continue;}
                if (dist[x][v] + dist[y][u] + edge[x][y] <= query[v][u]) {
                    cool[x][y] = 1;
                }
            }
        }
    }
}

void Solve() {
    memset(dist, -1, sizeof(dist));
    memset(edge, -1, sizeof(edge));
    memset(query, -1, sizeof(query));
    cin >> n >> m;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        dist[a][b] = dist[b][a] = edge[a][b] = edge[b][a] = c;
    }
    for (int i = 1; i <= n; ++i) {
        dist[i][i] = 0;
    }
    for (int mid = 1; mid <= n; ++mid) {
        for (int a = 1; a <= n; ++a) {
            for (int b = 1; b <= n; ++b) {
                if (dist[a][mid] == -1 || dist[mid][b] == -1) {continue;}
                if (dist[a][b] == -1 || dist[a][b] > dist[a][mid] + dist[mid][b]) {
                    dist[a][b] = dist[a][mid] + dist[mid][b];
                }
            }
        }
    }
/*    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            cout << dist[i][j] << ' ';
        }
        cout << '\n';
    }*/
    int q;
    cin >> q;
    vector<ti> all;
    all.resize(q);
    for (auto &[v, u, l] : all) {
        cin >> v >> u >> l;
        query[v][u] = query[u][v] = l;
    }
    Func();
    for (auto &[x, y, c] : all) {
        swap(x, y);
    }
    Func();
    int ans = 0;
    for(int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (cool[i][j]) {
                ++ans;
            }
        }
    }
    cout << ans;
}

signed main() {
    int start = clock();
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
#ifdef DIVAN
    cout << '\n' << "Time: " << (clock() - start + 999) / 1000 << '\n';
#endif
}
