#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const ll Inf = 1e18;
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, m;
  cin >> n >> m;
  vector <vector <ll>> d(n, vector <ll> (n, Inf));
  vector <vector <ll>> w(n, vector <ll> (n));
  for (int i = 0; i < n; ++i) d[i][i] = 0;
  for (int i = 0; i < m; ++i) {
    int u, v, ww;
    cin >> u >> v >> ww;
    --u, --v;
    d[u][v] = d[v][u] = ww;
    w[u][v] = w[v][u] = ww;
  }
  for (int k = 0; k < n; ++k) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
        d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
      }
    }
  }
  vector <vector <int>> ok(n, vector <int> (n));
  vector <vector <ll>> qr(n, vector <ll> (n, -Inf));
  int q;
  cin >> q;
  for (int i = 0; i < q; ++i) {
    int u, v, l;
    cin >> u >> v >> l;
    --u, --v;
    qr[u][v] = qr[v][u] = l;
  }
  for (int u = 0; u < n; ++u) {
    vector <ll> best(n, -Inf);
    for (int y = 0; y < n; ++y) {
      for (int v = 0; v < n; ++v) {
        best[y] = max(best[y], qr[u][v] - d[y][v]);
      } 
    }
    for (int x = 0; x < n; ++x) {
      for (int y = 0; y < n; ++y) {
        if (w[x][y]) {
          if (d[u][x] + w[x][y] <= best[y]) {
            ok[x][y] = 1;
          }
        }
      }
    }
  }
  int ans = 0;
  for (int x = 0; x < n; ++x) {
    for (int y = x + 1; y < n; ++y) {
      if (ok[x][y]) ++ans;
    }
  }
  cout << ans << '\n';
}

