//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define int long long

using namespace std;


const int maxn = 600 + 10;

const int inf = 1e9 * maxn + 7;


int d[maxn][maxn];

int ends_p[maxn][maxn];


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) d[i][j] = 0;
            else d[i][j] = inf;
        }
    }
    vector<tuple<int, int, int>> edge;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        d[u][v] = w;
        d[v][u] = w;
        edge.emplace_back(u, v, w);
        edge.emplace_back(v, u, w);
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            ends_p[k][i] = -1;
            for (int j = 0; j < n; ++j) {
                d[i][j] = min(d[i][k] + d[k][j], d[i][j]);
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int u, v, l;
        cin >> u >> v >> l;
        --u, --v;
        for (int j = 0; j < n; ++j) {
            ends_p[u][j] = max(ends_p[u][j], l - d[j][v]);
        }
    }
    set<pair<int, int>> good;
    for (auto[v, u, c]: edge) {
        for (int i = 0; i < n; ++i) {
            int dist_to = d[i][v] + c;
            if (ends_p[i][u] >= dist_to) {
                good.insert({min(v, u), max(u, v)});
                break;
            }
        }
    }
    cout << good.size();
    return 0;
}
