#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>


#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define sz(a) a.size()



using namespace std;


struct ask {
	int v;
	int l;


	ask() {}
	ask(int v, int l) : v(v), l(l) {}
};


int n, m;
vector<vector<int>> g;
vector<vector<int>> w;
vector<vector<ask>> asks;
vector<vector<bool>> good;
int q;


int get_mn(vector<int>& dst, vector<bool>& usd) {
	int rs = -1;
	for (int i = 0; i < n; ++i) {
		if (!usd[i]) {
			if (rs == -1 || dst[rs] > dst[i]) {
				rs = i;
			}
		}
	}
	return rs;
}


void dkstr1(vector<int> &dst) {
	vector<bool> usd(n, false);
	while (true) {
		int v = get_mn(dst, usd);
		if (v == -1) {
			break;
		}
		usd[v] = true;
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i];
			dst[to] = min(dst[to], dst[v] + w[v][i]);
		}
	}
}


void dkstr2(int v0) {
	vector<int> s(n, 1e18);
	for (auto &ask : asks[v0]) {
		s[ask.v] = -ask.l;
	}
	dkstr1(s);
	vector<int> dst(n, 1e18);
	dst[v0] = 0;
	vector<bool> usd(n, false);
	while (true) {
		int v = get_mn(dst, usd);
		if (v == -1) {
			break;
		}
		usd[v] = true;
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i];
			dst[to] = min(dst[to], dst[v] + w[v][i]);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < good[i].size(); ++j) {
			int u = i;
			int v = g[i][j];
			if (dst[u] + w[i][j] + s[v] <= 0) {
				good[i][j] = true;
			}
		}
	}
}


int get_res() {
	int rs = 0;
	for (int i = 0; i < n; ++i) {
		dkstr2(i);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < good[i].size(); ++j) {
			rs += good[i][j];
		}
	}
	return rs / 2;
}


int32_t main() {
	cin >> n >> m;
	g.resize(n);
	good.resize(n);
	w.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
		w[u].push_back(c);
		w[v].push_back(c);
		good[u].push_back(false);
		good[v].push_back(false);
	}
	cin >> q;
	asks.resize(n);
	for (int i = 0; i < q; ++i) {
		int u, v, l;
		cin >> u >> v >> l;
		--u;
		--v;
		asks[u].emplace_back(v, l);
		asks[v].emplace_back(u, l);
	}
	cout << get_res() << "\n";
	return 0;
}