#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#define int long long
using namespace std;
typedef vector<int> vi;

const int maxn = 601, inf = 1e18;
int dist[maxn][maxn];
int st[maxn][maxn];
int mx[maxn][maxn];
int bad[maxn][maxn];


void solve(){
	int n, m;
	cin >> n >> m;
	for(int i=0; i<maxn; i++){
		for(int j=0; j<maxn; j++){
			dist[i][j] = inf;
			st[i][j] = inf;
		}
	}
	for(int i=0; i<m; i++){
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		dist[a][b] = dist[b][a] = c;
		st[a][b] = st[b][a] = c;
	}
	for(int i=0; i<n; i++)
	    dist[i][i] = 0;
	for(int k=0; k<n; k++)
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++)
				dist[i][j] = min(dist[i][j], dist[i][k]+dist[k][j]);
	int q;
	cin >> q;
	vector<pair<pair<int, int>, int> > kek;
	for(int i=0; i<q; i++){
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		kek.push_back(make_pair(make_pair(a, b), c));
		swap(a, b);
		kek.push_back(make_pair(make_pair(a, b), c));
	}
	for(int i=0; i<kek.size(); i++){
		for(int j=0; j<n; j++){
			mx[j][kek[i].first.second] = max(mx[j][kek[i].first.second], kek[i].second - dist[j][kek[i].first.first]);
		}
	}
	for(int i=0; i<n; i++){
		for(int j=0; j<n; j++){
			if(i == j)
				continue;
			for(int k=0; k<n; k++){
				if(mx[j][k] >= dist[i][k] + st[i][j]){
					bad[i][j] = bad[j][i] = 1;
				}
			}
		}
	}
	int ans = 0;
	for(int i=0; i<n; i++)
		for(int j=i+1; j<n; j++)
			ans += bad[i][j];
	cout << ans << endl;
}

signed main(){
	int q = 1;
	// cin >> q;
	while(q--){
		solve();
	}
	// cin >> q;
	return 0;
}